@ raspiakkulader.s   letzte Aenderung: 6.4.2015
@ Laden von kleinen NiZn-Akkus
@ Schaltung: raspiakkulader.png
@ Es wird der 12Bit-AD-Wandler MCP3208 verwendet.
@ Es koennen 2 Akkus unabhaengig voneinander entladen und geladen werden.

@ Variante fuer Auswahl zwischen Linux und "bare-metal":
@.equ LINUX_VERSION, 1  @ auskommentieren fuer "bare-metal"
.include "anfang.s"
	b hauptprogramm
.include "raspisammlung.s"

	.data
gpio_adresse:	.word	0
timer_adresse:	.word	0
starttext: .string "Akkulader fuer NiZn-Akkus"
	.align
referenzspannung:
	.word 2461	@ Uref in mV (ausgemessen)
akkudaten:
	.word 1600	@ Normale Spannung eines Akkus in mV
uleer:	.word 1300	@ Spannung wenn entladen
uvoll:	.word 1900	@ Spannung wenn voll geladen
ladestrom: .word 110	@ Ladestrom in mA
erhaltstrom: .word 18	@ Ladestrom fuer Erhaltungsladung
	.text

@ GPIO-Nummern:
.equ GPIO_LADEN_L, 17
.equ GPIO_ENTLAD_L, 18
.equ GPIO_LADEN_R, 22
.equ GPIO_ENTLAD_R, 27

.equ PWMFREQUENZ, 10000  @ 10kHz PWM-Frequenz

hauptprogramm:	@ r7=GPIO-Adresse, r8=Timer-Basisadresse
	ldr r4, =gpio_adresse
	str r7, [r4]
	ldr r4, =timer_adresse
	str r8, [r4]
	bl gpio_init
	bl InitFrameBuffer
	tst r0,r0
	beq halt		@ bei Fehler anhalten
	mov r0, #0		@ Farbe=schwarz
	bl clearscreen		@ Bildschirm loeschen
	mov r0, #0		@ x-Koordinaten
	mov r1, #36		@ y-Koordinaten
	mov r0, #2		@ groesserer Text
	bl setfontscale
	ldr r3, =starttext
	bl printstring
	ldr r6, =akkudaten
	bl print_newline
	.data
text1:	.string "Normalspannung: "
	.align
	.text
	ldr r3, =text1
	ldr r4, [r6]
	mov r5, #'V'
	bl print_text_zahl
	.data
text2:	.string "Spannung wenn Leer: "
	.align
	.text
	ldr r3, =text2
	ldr r4, [r6,#4]
	bl print_text_zahl
	.data
text3:	.string "Endspannung beim Laden: "
	.align
	.text
	ldr r3, =text3
	ldr r4, [r6,#8]
	bl print_text_zahl
	.data
text4:	.string "Ladestrom: "
	.align
	.text
	ldr r3, =text4
	ldr r4, [r6,#12]
	mov r5, #'A'
	bl print_text_zahl
	.data
text5:	.string "Erhaltungsladung wenn voll: "
	.align
	.text
	ldr r3, =text5
	ldr r4, [r6,#16]
	bl print_text_zahl

@ Interrupts initialisieren fuer Uhr und PWM:
	bl pause_set_start
	bl irq_init
	tst r0, r0
	beq irq_init_erfolgreich
	.data
fehler1:.string "Fehler bei irq_init"
	.align
	.text
	ldr r3, =fehler1
	mov r0, #0
	bl printstring
	b halt
irq_init_erfolgreich:

@ Test der Interrupt-Uhr:
	.data
uhrtest:.string "Uhr testen:"
	.align
	.text
	ldr r3, =uhrtest
	bl printstring
	bl print_newline
	mov r5, #60
L1:	ldr r4, =uhrdaten
	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5
	beq L1
	tst r3, #1	@ Test alle 2 Sekunden: PWM1 erniedrigen
	bleq pwm1_aendern
	tst r3, #0	@ Test alle 1 Sekunden: PWM2 erhoehen
	bleq pwm2_aendern
	mov r5, r3		@ r5=Sekunden
	ldrb r6, [r4,#5]	@ Minuten lesen
	ldrb r3, [r4,#6]	@ Stunden lesen
	mov r2, #2		@ Format: 2 Stellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r6
	add r2, #'0'<<24	@ Format: mit 0 auffuellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r5
	bl printzahl
	mov r2, #4		@ noch PWM1 und PWM2 drucken
	ldrb r3, [r4,#16]	@ pwm1
	bl printzahl
	ldrb r3, [r4,#17]	@ pwm2
	bl printzahl
	mov r0, #0		@ wieder auf Zeilenanfang
	b L1

pwm2_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm2
	ldrb r0,[r2]
	add r0,#1
	b pwm1_1
pwm1_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm1
	ldrb r0,[r2]
	sub r0,#1
pwm1_1:	tst r0,r0		@ r0<0 ?
	addmi r0,#100		@ ja: 100 addieren
	cmp r0,#100		@ r0>=100 ?
	subcs r0,#100		@ ja: 100 subtrahieren
	strb r0,[r2]
	pop {r0,r2,pc}

/*
@ Test ohne eingesetzte Akkus:
testloop:
	mov r1, #0	@ alle Transistoren ausschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #1	@ Transistoren einschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	b testloop
*/
	
halt:	b halt

pause:	push {r0,lr}
	mov r0, #4000
	add r0, #1000
	bl milliwait	@ 5 Sekunden warten
	pop {r0,pc}

@ entspricht: printf("%s%d m%c\n",char* Text,int Zahl,char Einheit)
print_text_zahl: @ r3=Zeiger auf Text, r4=Zahl, r5=Einheit
	push {r2-r3,lr}
	bl printstring
	mov r2, #0	@ unformattiert
	mov r3, r4
	bl printzahl
	bl printblank
	mov r3, #'m'
	bl printchar
	mov r3, r5
	bl printchar	@ mV oder mA
	bl print_newline
	pop {r2-r3,pc}

gpio_init:
	push {r0-r1,lr}
	mov r1, #1	@ als Ausgang schalten:
	mov r0, #GPIO_LADEN_L	@ GPIO17, laden links
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_L	@ GPIO18, entladen links
	bl gpio_init1
	mov r0, #GPIO_LADEN_R	@ GPIO22, laden rechts
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_R	@ GPIO27, entladen rechts
	bl gpio_init1
	mov r0, #8	@ GPIO08, CS fuer AD-Wandler (MCP3208)
	bl gpio_init1
	bl gpio_ein_aus	@ CS auf High setzen fuer inaktiv
	mov r0, #11	@ GPIO11, CLK fuer AD-Wandler
	bl gpio_init1
	mov r0, #10	@ GPIO10, DIN fuer AD-Wandler
	bl gpio_init1
	mov r1, #0	@ als Eingang schalten:
	mov r0, #9	@ GPIO09, DOUT von AD-Wandler
	bl gpio_init1
	pop {r0-r1,pc}

@ ---------------------------------------------------------------------
@ Interrupts
	.data
uhrdaten:
                          @ Adr Kommentar
	.word PWMFREQUENZ @ 0   Ticks, werden mit 10kHz runtergezaehlt
	.byte 0		  @ 4   Sekunden
	.byte 0 	  @ 5   Minuten
	.byte 0		  @ 6   Stunden
	.byte 0		  @ 7   Reserve
                          @ Adr Kommentar
endzeitpunkt: .word 0	  @ 8   Zeitpunkt wenn ein Ladetransistor gesetzt und Uhr aktualisiert wird
pwmzeitpunkt: .word 0	  @ 12  Zeitpunkt wenn der Ladetransistor wieder ausgeschaltet wird
pwm1:	.byte 50	  @ 16  Werte von 0 bis 95 erlaubt
pwm2:	.byte 50	  @ 17  Werte von 0 bis 95 erlaubt
pwmstatus: .byte 0	  @ 18  gerade aktiver PWM, 0=PWM1 (linker), 1=PWM2 (rechter Transistor)
	.byte 0		  @ 19  Reserve
pwmfreq:.word PWMFREQUENZ @ 20  PWM-Frequenz
	.text

pause_set_start:
        push {r0-r2,lr}
	ldr r2, =uhrdaten
        ldr r1, [r8,#4]		@ Zaehler des Timers einlesen, nur untere 32-Bit
	str r1, [r2,#8]		@ Endzeitpunkt speichern
	bl pause_set
	ldr r0, [r2,#16]
	bl pwmpause_set
	pop {r0-r2,pc}

pause_set:	@ Parameter: r2=uhrdaten
		@ Rueckgabe: r1 zerstoert
        ldr r1, [r2,#8]		@ vorheriger Endzeitpunkt laden
	add r1, #(1000000/PWMFREQUENZ)	@ neuer Endzeitpunkt berechnen, 100us fuer 10kHz, 1000us fuer 1kHz
	str r1, [r2,#8]		@ Endzeitpunkt speichern
        str r1, [r8,#16]	@ speichern im Vergleichsregister "Compare 1"
        mov r1, #0b10		@ M1
        str r1, [r8,#0]		@ Bit M1 im CS ruecksetzen
	mov pc, lr

pwmpause_set:	@ Parameter: r0=PWM-Dauer, r2=uhrdaten
		@ Rueckgabe: r0-r1 zerstoert
.ifdef NUR1KHZ
	mov r1, #10	@test bei 1kHz mit 10 multiplizieren
	mul r0, r1	@test bei 1kHz mit 10 multiplizieren
.endif
	cmp r0, #5		@ auf Minimalwert testen
	movcc r0, #5
	cmp r0, #95+1		@ auf Maximalwert testen
	movcs r0, #95
	ldr r1, [r2,#8]		@ endzeitpunkt laden
	add r1, r0		@ neuer pwmzeitpunkt berechnen
	str r1, [r2,#12]	@ pwmzeitpunkt speichern
	str r1, [r8,#24]	@ speichern im Vergleichsregister "Compare 3"
	mov r1, #0b1000		@ M3
	str r1, [r8,#0]		@ Bit M3 im CS ruecksetzen
	mov pc, lr

irq_routine:
	push {r0-r2,r7-r8,lr}
	ldr r8, =timer_adresse
	ldr r8, [r8]
	ldr r0, [r8,#0]
	tst r0, #0b1000		@ M3 gesetzt?
	bne irq_pwm		@ ja-->
	tst r0, #0b10		@ M1 gesetzt?
	bne irq_timer		@ ja-->
irq_taster:			@ nein: Taster-Interrupts
	@ noch zu machen
	b irq_ret
irq_timer:
	ldr r2, =uhrdaten
	bl pause_set
	ldr r0, [r2]		@ Ticks
	subs r0, #1
	bne irq_1
	ldr r0, [r2,#20]	@ pwmfreq, Ticks wieder auf 10000 setzen bei 10kHz
	ldrb r1, [r2,#4]	@ Sekunden
	add r1, #1
	cmp r1, #60
	bne irq_2
	mov r1, #0		@ Sekunden wieder auf 0
	ldrb r7, [r2,#5]	@ Minuten
	add r7, #1
	cmp r7, #60
	bne irq_3
	ldrb r7, [r2,#6]	@ Stunden
	add r7, #1
	strb r7, [r2,#6]
	mov r7, #0		@ Minuten wieder auf 0
irq_3:	strb r7, [r2,#5]	@ Minuten speichern
irq_2:	strb r1, [r2,#4]	@ Sekunden speichern
irq_1:	str r0, [r2]		@ Ticks speichern
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	ldrb r1, [r2,#18]	@ pwmstatus
	tst r1, r1
	moveq r0, #(1<<GPIO_LADEN_L)	@ Linker Ladetransistor wenn pwmstatus==0
	movne r0, #(1<<GPIO_LADEN_R)	@ Rechter Ladetransistor wenn pwmstatus==1
	ldreqb r1, [r2,#16]		@ pwm1 oder
	ldrneb r1, [r2,#17]		@ pwm2 laden
	cmp r1, #5		@ mindestens Minimalwert?
	strcs r0, [r7,#28]	@ ja: Ladetransistor ein
irq_ret:pop {r0-r2,r7-r8,lr}
	subs pc, lr, #4		@ Ruecksprung vom Interrupt
irq_pwm:
	ldr r2, =uhrdaten
	ldrb r1, [r2,#18]	@ pwmstatus
	eors r1, #1		@ Bit 0 umkehren
	strb r1, [r2,#18]	@ pwmstatus
	ldreqb r0, [r2,#16]	@ pwm1 fuer Links
	ldrneb r0, [r2,#17]	@ pwm2 fuer Rechts
	bl pwmpause_set
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	mov r1, #(1<<GPIO_LADEN_R)|(1<<GPIO_LADEN_L)
	str r1, [r7,#40]	@ beide Ladetransistoren aus
	pop {r0-r2,r7-r8,lr}
	subs pc, lr, #4		@ Ruecksprung vom Interrupt

adr_irq_routine:
	.word irq_routine

irq_init:	@ Rueckgabe wenn erfolgreich: r0=0
	push {r1-r2,lr}
	mrs r0, cpsr            @ aktueller Modus in r0 sichern
	mov r1, #0xD2           @ in IRQ-Modus schalten
        msr cpsr_ctl, r1
        mov sp, #0x6000         @ Stack Pointer fuer IRQ-Modus setzen
        msr cpsr_ctl, r0        @ in vorherigen Modus zurueck
	mov r2, #0x18		@ Adresse des irq-Interrupt-Vectors
	ldr r1, adr_irq_routine	@ Adresse der irq_routine
	sub r1, r2
	sub r1, #8		@ Berechung der Sprungdistanz
	lsr r1, #2		@ Dividieren durch 4 fuer Distanz in 4-Byte-Worten
	add r1, #0xEA000000	@ Code des Sprungbefehls addieren
	str r1, [r2]		@ irq-Interrupt-Vector setzen
	@ Flags zum IRQ erlauben setzen, im CPSR und im Interrupt-Controller:
	mrs r0, cpsr
	bic r0, #0x80		@ IRQ-Disable auf 0 setzen
	msr cpsr_ctl, r0
	@mov r0, #(1<<1)	@ IRQ 1 erlauben fuer Systemtimer Compare1
	@str r0, [r9,#0x210]	@ in "Enable IRQs 1" entsprechendes Bit setzen
	mov r0, #(1<<1)|(1<<3)	@ IRQ 1 und IRQ 3 erlauben fuer Systemtimer Compare1 und Compare3
	str r0, [r9,#0x210]	@ in "Enable IRQs 1" entsprechende Bits setzen
	ldr r0, [r2]		@ irq-Vector nochmals lesen
	sub r0, r1		@ vergleichen mit was es sein sollte
	pop {r1-r2,pc}
