@ raspiakkulader.s   letzte Aenderung: 18.4.2015
@ Laden von kleinen NiZn-Akkus
@ Schaltung: raspiakkulader.png
@ Es wird der 12Bit-AD-Wandler MCP3208 verwendet.
@ Es koennen 2 Akkus unabhaengig voneinander entladen und geladen werden.

@ Variante fuer Auswahl zwischen Linux und "bare-metal":
@.equ LINUX_VERSION, 1  @ auskommentieren fuer "bare-metal"
.include "anfang.s"
	b hauptprogramm
@.include "raspisammlung.s"
@ Problem wenn Programm zu gross: invalid literal constant: pool needs to be closer
@ Vermeidung des Problems: "ldr rx, =Name" ersetzen

@ -----------------------------------------------------------------
@ Tests zum debuggen, in endgueltigem Programm alle auskommentieren
@.equ TRANSTEST, 1	@ Testen der Transistoren
@.equ UHRTEST, 1 	@ Testen der Interrupt-Uhr und PWM
@.equ ADTEST, 1		@ AD-Wandler testen
@ -----------------------------------------------------------------

@ GPIO-Nummern:
.equ GPIO_LADEN_L, 17
.equ GPIO_ENTLAD_L, 18
.equ GPIO_LADEN_R, 22
.equ GPIO_ENTLAD_R, 27

.equ PWMFREQUENZ, 10000  @ 10kHz PWM-Frequenz (weitere Aenderungen noetig bei anderen Werten)
@.equ NUR1KHZ, 1         @ benoetigt wenn oben auf 1000 gesetzt

@ Problem wenn Programm zu gross: invalid literal constant: pool needs to be closer
@ Provisorisch zuerst Unterprogramme, die kein "ldr rx, =" machen.

@ ---------------------------------------------------------------------
@ GPIO
gpio_init:
	push {r0-r1,lr}
	mov r1, #1	@ als Ausgang schalten:
	mov r0, #GPIO_LADEN_L	@ GPIO17, laden links
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_L	@ GPIO18, entladen links
	bl gpio_init1
	mov r0, #GPIO_LADEN_R	@ GPIO22, laden rechts
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_R	@ GPIO27, entladen rechts
	bl gpio_init1
	mov r0, #8	@ GPIO08, CS fuer AD-Wandler (MCP3208)
	bl gpio_init1
	bl gpio_ein_aus	@ CS auf High setzen fuer inaktiv
	mov r0, #11	@ GPIO11, CLK fuer AD-Wandler
	bl gpio_init1
	mov r0, #10	@ GPIO10, DIN fuer AD-Wandler
	bl gpio_init1
	mov r1, #0	@ als Eingang schalten:
	mov r0, #9	@ GPIO09, DOUT von AD-Wandler
	bl gpio_init1
	pop {r0-r1,pc}

entladetransistoren_einschalten:  @ Eingabe: r4=uhrdaten
	push {r0-r1,lr}
	mov r0, #0
	strb r0, [r4,#16]	@ pwm1 ausschalten
	strb r0, [r4,#17]	@ pwm2 ausschalten
	mov r1, #1
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	pop {r0-r1,pc}

@ --------------------------------------------------------------------------------------------
alle_spannungen_messen:  @ Eingabe r6=Zeiger auf Messwerte
			 @ r10=Flags, 0x0F=links 0xF0=rechts, 1=Entladen, 2=Laden, 4=Erhaltung
	push {r0-r3,lr}
	mov r0, #0		@ Kanal 0, obere Spannung links
	mov r1, #256		@ Anzahl Aufsummierungen
	bl adwandlung		@ r3=Resultat
	bl messwert_in_spannung_umrechnen	@ r3=Resultat in mV
	mov r2, r3
	mov r0, #1		@ Kanal 1, Akku-Spannung links
	bl adwandlung
	bl messwert_in_spannung_umrechnen
	str r3, [r6,#4]		@ Spannung links
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	mov r1, r3
	bl strom_ausrechnen	@ r3=Resultat in mA
	str r3, [r6,#0]		@ Ladestrom links
	mov r0, #2		@ Kanal 2, obere Spannung rechts
	mov r1, #256		@ Anzahl Aufsummierungen
	bl adwandlung		@ r3=Resultat
	bl messwert_in_spannung_umrechnen	@ r3=Resultat in mV
	mov r2, r3
	mov r0, #3		@ Kanal 3, Akku-Spannung rechts
	bl adwandlung
	bl messwert_in_spannung_umrechnen
	str r3, [r6,#12]	@ Spannung rechts
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	mov r1, r3
	bl strom_ausrechnen	@ r3=Resultat in mA
	str r3, [r6,#8]		@ Ladestrom rechts
	mov r0, #9472
	add r0, #28		@ 9500 mOhm Entlade-Widerstand (2.5+6.8+0.2 Ohm)
	ldr r1, [r6,#4]		@ Spannung links
	mov r2, #0
	bl strom_ausrechnen
	str r3, [r6,#16]	@ Entladestrom links falls Entladezyklus
	ldr r1, [r6,#12]	@ Spannung rechts
	bl strom_ausrechnen
	str r3, [r6,#20]	@ Entladestrom rechts falls Entladezyklus
	tst r10, #1		@ Entlade links ?
	beq alsp1		@ nein-->
	ldr r0, [r6,#24]	@ Entladekap links
	ldr r3, [r6,#16]	@ Entladestrom links
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#24]
alsp1:	tst r10, #0x10		@ Entlade rechts ?
	beq alsp2		@ nein-->
	ldr r0, [r6,#28]	@ Entladekap rechts
	ldr r3, [r6,#20]	@ Entladestrom rechts
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#28]
alsp2:	tst r10, #2		@ Laden links ?
	beq alsp3		@ nein-->
	ldr r0, [r6,#32]	@ Ladekap links
	ldr r3, [r6,#0]		@ Ladestrom links
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#32]
alsp3:	
	tst r10, #0x20		@ Laden rechts ?
	beq alsp4		@ nein-->
	ldr r0, [r6,#36]	@ Ladekap rechts
	ldr r3, [r6,#8]		@ Ladestrom rechts
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#36]
alsp4:	pop {r0-r3,pc}

@ Ende der Unterprogramme, die kein "ldr rx, =" machen.
@ ---------------------------------------------------------------------
.include "raspisammlung.s"

	.data
gpio_adresse:	.word	0
timer_adresse:	.word	0
starttext: .string "Akkulader fuer NiZn-Akkus"
	.align
Akkudaten:
unorm:	.word 1600	@  0  Normale Spannung eines Akkus in mV
uleer:	.word 1300	@  4  Spannung wenn entladen
uvoll:	.word 1900	@  8  Spannung wenn voll geladen
ladestrom: .word 110	@ 12  Ladestrom in mA (fuer 550mAh Akkus)
erhaltstrom: .word 18	@ 16  Ladestrom fuer Erhaltungsladung
vollkap:.word 550*3600	@ 20  Volle Kapazitaet eines Akkus (in mAsec)

Messwerte:	@ wird von "alle_spannungen_messen" ausgefuellt
	.word 0		@  0  Ladestrom links
	.word 0		@  4  Spannung links
	.word 0		@  8  Ladestrom rechts
	.word 0		@ 12  Spannung rechts
	.word 0		@ 16  Entladestrom links
	.word 0		@ 20  Entladestrom rechts
	.word 0		@ 24  Entladekapazitaet links
	.word 0		@ 28  Entladekapazitaet rechts
	.word 0		@ 32  Ladekapazitaet links
	.word 0		@ 36  Ladekapazitaet rechts
	.text
adr_gpio_adresse:.word gpio_adresse
adr_timer_adresse:.word timer_adresse
adrAkkudaten:	.word Akkudaten
adrMesswerte:	.word Messwerte

hauptprogramm:	@ r7=GPIO-Adresse, r8=Timer-Basisadresse
	ldr r4, adr_gpio_adresse
	str r7, [r4]
	ldr r4, adr_timer_adresse
	str r8, [r4]
	bl gpio_init
	bl InitFrameBuffer
	tst r0,r0
	beq halt		@ bei Fehler anhalten
	mov r0, #0		@ Farbe=schwarz
	bl clearscreen		@ Bildschirm loeschen
	mov r0, #0		@ x-Koordinaten
	mov r1, #36		@ y-Koordinaten
	mov r0, #2		@ groesserer Text
	bl setfontscale
	ldr r3, =starttext
	bl printstring
	ldr r6, adrAkkudaten
	bl print_newline
	.data
text1:	.string "Normalspannung: "
	.align
	.text
	ldr r3, =text1
	ldr r4, [r6]
	mov r5, #'V'
	bl print_text_zahl
	.data
text2:	.string "Spannung wenn Leer: "
	.align
	.text
	ldr r3, =text2
	ldr r4, [r6,#4]
	bl print_text_zahl
	.data
text3:	.string "Endspannung beim Laden: "
	.align
	.text
	ldr r3, =text3
	ldr r4, [r6,#8]
	bl print_text_zahl
	.data
text4:	.string "Ladestrom: "
	.align
	.text
	ldr r3, =text4
	ldr r4, [r6,#12]
	mov r5, #'A'
	bl print_text_zahl
	.data
text5:	.string "Erhaltungsladung wenn voll: "
	.align
	.text
	ldr r3, =text5
	ldr r4, [r6,#16]
	bl print_text_zahl

@ Interrupts initialisieren fuer Uhr und PWM:
	bl pause_set_start
	bl irq_init
	tst r0, r0
	beq irq_init_erfolgreich
	.data
fehler1:.string "Fehler bei irq_init"
	.align
	.text
	ldr r3, =fehler1
	mov r0, #0
	bl printstring
	b halt
irq_init_erfolgreich:

.ifdef TRANSTEST
@ Test der Transistoren ohne eingesetzte Akkus:
testloop:
	mov r1, #0	@ alle Transistoren ausschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #1	@ Transistoren einschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	b testloop
pause:	push {r0,lr}
	mov r0, #4000
	add r0, #1000
	bl milliwait	@ 5 Sekunden warten
	pop {r0,pc}
.endif @ TRANSTEST

.ifdef UHRTEST
@ Test der Interrupt-Uhr:
	.data
uhrtest:.string "Uhr testen:"
	.align
	.text
	ldr r3, =uhrtest
	bl printstring
	bl print_newline
	mov r5, #60
	ldr r4, adrUhrdaten
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5
	beq L1
	tst r3, #1	@ Test alle 2 Sekunden: PWM1 erniedrigen
	bleq pwm1_aendern
	tst r3, #0	@ Test alle 1 Sekunden: PWM2 erhoehen
	bleq pwm2_aendern
	mov r5, r3		@ r5=Sekunden
	ldrb r6, [r4,#5]	@ Minuten lesen
	ldrb r3, [r4,#6]	@ Stunden lesen
	mov r2, #2		@ Format: 2 Stellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r6
	add r2, #'0'<<24	@ Format: mit 0 auffuellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r5
	bl printzahl
	mov r2, #4		@ noch PWM1 und PWM2 drucken
	ldrb r3, [r4,#16]	@ pwm1
	bl printzahl
	ldrb r3, [r4,#17]	@ pwm2
	bl printzahl
	bl pwm_check	@ zum Debuggen
	beq L2		@ ok -->
	bl pwm_restart
	mov r2, #12
	bl printzahl	@ Zaehler Timer
	mov r3, r6
	bl printzahl	@ Zaehler PWM
	bl print_newline
L2:	mov r0, #0		@ wieder auf Zeilenanfang
	b L1

pwm2_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm2
	ldrb r0,[r2]
	add r0,#1
	b pwm1_1
pwm1_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm1
	ldrb r0,[r2]
	sub r0,#1
pwm1_1:	tst r0,r0		@ r0<0 ?
	addmi r0,#100		@ ja: 100 addieren
	cmp r0,#100		@ r0>=100 ?
	subcs r0,#100		@ ja: 100 subtrahieren
	strb r0,[r2]
	pop {r0,r2,pc}
.endif @ UHRTEST

.ifdef ADTEST
	.data
adtest:.string "AD-Wandler testen:"
	.align
	.text
	ldr r3, =adtest
	bl printstring
	bl print_newline
	ldr r4, adrUhrdaten
	ldr r6, adrMesswerte
	mov r5, #0	@ r5=Sekunden
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5		@ Sekunden geaendert?
	beq L1			@ nein--> warten
	mov r5, r3
	push {r0,r1}	@ x,y retten
	push {r0-r1}	@ x retten
	mov r0, #0	@ Kanal 0, Ladestrom links
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#0]
	mov r2, #6	@ Format "%6d"
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #1	@ Kanal 1, Akku-Spannung links
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#4]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #2	@ Kanal 2, Ladestrom rechts
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#8]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #3	@ Kanal 3, Akku-Spannung rechts
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#12]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	ldrb r3, [r4,#4]	@ Sekunden lesen
	bl printzahl
	bl print_newline	@ auf naechster Zeile in mV umgerechnete Werte
	ldr r3, [r6,#0]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#4]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#8]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#12]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	bl printblank
	bl printblank
	bl print_mV
	bl print_newline	@ auf naechster Zeile Lade-Stroeme anzeigen
	push {r0-r2}
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	ldr r1, [r6,#0]
	ldr r2, [r6,#4]
	bl strom_ausrechnen
	pop {r0-r2}
	bl printzahl		@ Strom links
	bl printblank
	bl print_mA
	bl printblank
	bl printblank
	push {r0-r2}
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	ldr r1, [r6,#8]
	ldr r2, [r6,#12]
	bl strom_ausrechnen
	pop {r0-r2}
	bl printzahl		@ Strom rechts
	bl printblank
	bl print_mA
	cmp r3, #18+10	@ Regelungsversuch auf 18 mA
	blcs zu_hoch
	cmp r3, #18-10	@ Regelungsversuch
	blcc zu_niedrig
	pop {r0,r1}	@ x,y zurueck
	b L1
zu_hoch:
	push {r0,lr}
	ldrb r0, [r4,#17]	@ pwm2
	subs r0, #1
	strcsb r0, [r4,#17]
	pop {r0,pc}
zu_niedrig:
	push {r0,lr}
	ldrb r0, [r4,#17]	@ pwm2
	add r0, #1
	cmp r0, #99
	strccb r0, [r4,#17]
	pop {r0,pc}

.endif @ ADTEST

@ Hauptprogramm:
	.data
txtentlad1:	.string "Entladezyklus wird in 30 Sekunden gestartet"
	.align
txtentlad2:	.string "Entladezyklus gestartet                    "
	.align
txtladen:	.string "Ladezyklus gestartet                       "
	.align
txterhalt:	.string "Erhaltungsladung                           "
	.align
txtlinks:	.string "Linker Akku: "
	.align
txtrechts:	.string "Rechter Akku:"
	.align
txtleer:	.string "             "
	.align
	.text
	bl print_newline
	mov r9, r1		@ r9=y-Position von erster Textzeile
	mov r10, #0		@ r10=Flags, 0x0F=links 0xF0=rechts, 1=Entladen, 2=Laden, 4=Erhaltung
	mov r11, #0		@ r11=Anzahl verlorene Sekunden (zum ueberpruefen ob Timing korrekt ist)
	ldr r3, =txtentlad1
	bl printstring
	bl print_newline
	ldr r4, adrUhrdaten
	ldr r6, adrMesswerte
	mov r5, #0		@ r5=Sekunden
	mvn r2, #0		@ r2= -1 (nicht loeschen)
	@mov r2, #0xFF0000	@ r2=Blau
	@mov r3, #1		@ xmax = 1 Stunde
	mvn r3, #30-1		@ xmax = 30 Minuten
	bl grafische_darstellung_init  @ r2=Farbe zum loeschen oder -1, r3=xmax in Std oder Min wenn negativ
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5		@ Sekunden geaendert?
	beq L1			@ nein--> warten

	@ Test auf verlorene Sekunden:
	add r5, #1		@ r5=berechnete neue Sekunde
	cmp r5, #60
	moveq r5, #0
	cmp r5, r3		@ stimmt es mit aktueller Sekunde ueberein?
	addne r11, #1		@ Nein: Anzahl verlorene Sekunden erhoehen
	blne print_verlorene_sekunden

	mov r5, r3
	push {r0-r1}		@ x,y Position sichern
	bl alle_spannungen_messen
	bl eventuell_pwm_regeln	@ abhaengig von Flags in r10
	bl grafische_darstellung

	mov r3, #0
	bl zeile_mit_werten_anzeigen	@ r3=0 fuer linken Akku
	bl print_newline
	mov r3, #1
	bl zeile_mit_werten_anzeigen	@ r3=1 fuer rechten Akku
	
	pop {r0-r1}		@ im naechsten Durchgang wieder selbe 2 Zeilen ueberschreiben
	tst r10,r10		@ falls Flags schon gesetzt, dann wurde schon begonnen
	bne L2
	cmp r5, #30		@ sonst nach 30 Sekunden Entladezyklus beginnen
	bne L1
	bl entladetransistoren_einschalten
	mov r10, #0x11		@ Entladeflags setzen
	ldr r3, =txtentlad2
	bl meldung_auf_erste_zeile
	@bl testpause
	b L1
L2:	push {r0-r1}
	ldr r2, adrAkkudaten
	ldr r3, [r6,#4]		@ Spannung links
	tst r10, #0x01		@ Entladeflag fuer Links gesetzt?
	beq volltestL		@ nein-->
leertestL:
	ldr r1, [r2,#4]		@ uleer
	cmp r3, r1		@ Spannung < uleer ?
	blcc ladezyklus_links_starten	@ ja: Ladezyklus beginnen
	b leertestR
volltestL:
	ldr r1, [r2,#8]		@ uvoll
	sub r1, #100
	cmp r3, r1		@ Spannung >= uvoll-100mV ?
	bcc leertestR		@ nein--> noch nicht voll
	ldr r1, [r6,#32]	@ Ladekap links
	ldr r3, [r2,#20]	@ Vollkap
	cmp r3, r1		@ Ladekap > Vollkap ?
	blcc erhaltungszyklus_links	@ ja: Erhaltungsladung
leertestR:
	ldr r3, [r6,#12]	@ Spannung rechts
	tst r10, #0x10		@ Entladeflag fuer Rechts gesetzt?
	beq volltestR		@ nein-->
	ldr r1, [r2,#4]		@ uleer
	cmp r3, r1		@ Spannung < uleer ?
	blcc ladezyklus_rechts_starten	@ ja: Ladezyklus beginnen
	b L3
volltestR:
	ldr r1, [r2,#8]		@ uvoll
	sub r1, #100
	cmp r3, r1		@ Spannung >= uvoll-100mV ?
	bcc L3			@ nein--> noch nicht voll
	ldr r1, [r6,#36]	@ Ladekap rechts
	ldr r3, [r2,#20]	@ Vollkap
	cmp r3, r1		@ Ladekap > Vollkap ?
	blcc erhaltungszyklus_rechts	@ ja: Erhaltungsladung
L3:	pop {r0-r1}
	ldr r3, =txtladen
	tst r10,#0x22		@ mindestens eins der Ladeflags gesetzt?
	blne meldung_auf_erste_zeile
	ldr r3, =txterhalt
	cmp r10,#0x44		@ beide Erhaltungslade-Flags gesetzt?
	bleq meldung_auf_erste_zeile
	b L1

zeile_mit_werten_anzeigen:  @ r3 = 0 fuer Linker, 1 fuer rechter Akku
			    @ r6=Zeiger auf Messwerte, r10=Flags
			    @ r0,r1 = x,y  wird entsprechend erhoeht
	push {r2-r4,r10,lr}
	mov r4, r3
	tst r4, #1
	ldreq r3, =txtlinks
	ldrne r3, =txtrechts
	bl printstring
	tst r4, #1
	ldreq r3, [r6,#4]	@ Spannung links
	ldrne r3, [r6,#12]	@ Spannung rechts
	mov r2, #6
	bl printzahl
	bl printblank
	bl print_mV
	tst r4, #1
	bne z1
	tst r10, #1
	ldrne r3, [r6,#16]	@ Entladestrom links
	ldreq r3, [r6,#0]	@ Ladestrom links
	b z2
z1:	lsr r10, #4
	tst r10, #1
	ldrne r3, [r6,#20]	@ Entladestrom rechts
	ldreq r3, [r6,#8]	@ Ladestrom rechts
z2:	bl printzahl
	bl printblank
	bl print_mA
	tst r4, #1
	ldreq r3, [r6,#24]	@ Entladekap links
	ldrne r3, [r6,#28]	@ Entladekap rechts
	bl print_kapazitaet
	tst r4, #1
	ldreq r3, [r6,#32]	@ Ladekap links
	ldrne r3, [r6,#36]	@ Ladekap rechts
	tst r10, #6
	blne print_kapazitaet
	pop {r2-r4,r10,pc}

testpause:	@ zum Debuggen
	push {r0,lr}
	mov r0, #4000
	add r0, #1000
	bl milliwait	@ 5 Sekunden warten
	pop {r0,pc}

meldung_auf_erste_zeile:  @ Eingabe r3=Text
	push {lr}
	mov r1, r9		@ in erste Textzeile schreiben
	bl printstring
	bl print_newline
	pop {pc}

	.data
Verlorentxt:	.string	" Verlorene Sekunden:"
	.align
	.text
adrVerlorentxt:	.word Verlorentxt

print_verlorene_sekunden:  @ Eingabe: r11=Anzahl verlorene Sekunden, keine Reg veraendert
	push {r0-r3,lr}
	mov r1, r9		@ erste Zeile
	mov r0, #1088		@ etwas nach der Mitte der Zeile
	ldr r3, adrVerlorentxt
	bl printstring
	mov r3, r11
	mov r2, #3
	bl printzahl
	pop {r0-r3,pc}

ladezyklus_links_starten:
	push {r0-r1,lr}
	mov r1, #0		@ Entladetransistor ausschalten
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	and r10, #0xF0
	orr r10, #0x02		@ Ladeflag Links setzen
	mov r0, #40
	strb r0, [r4,#16]	@ pwm1 einschalten
	pop {r0-r1,pc}

ladezyklus_rechts_starten:
	push {r0-r1,lr}
	mov r1, #0		@ Entladetransistor ausschalten
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	and r10, #0x0F
	orr r10, #0x20		@ Ladeflag Rechts setzen
	mov r0, #40
	strb r0, [r4,#17]	@ pwm2 einschalten
	pop {r0-r1,pc}

erhaltungszyklus_links:
	push {r0-r1,lr}
	and r10, #0xF0
	orr r10, #0x04		@ Erhaltungsflag Links setzen
	mov r0, #12		@ PWM-Wert fuer etwa 18 mA
	strb r0, [r4,#16]	@ pwm1 setzen
	pop {r0-r1,pc}

erhaltungszyklus_rechts:
	push {r0-r1,lr}
	and r10, #0x0F
	orr r10, #0x40		@ Erhaltungsflag Rechts setzen
	mov r0, #12		@ PWM-Wert fuer etwa 18 mA
	strb r0, [r4,#17]	@ pwm2 setzen
	pop {r0-r1,pc}

halt:	b halt

pwm_regeln:  @ Eingabe: r0=Sollwert in mA, r1=Maxwert in mV, r2=pwm-Nr (0=pwm1, 1=pwm2)
	push {r0,r2-r5,lr}
	ldr r4, =pwm1
	and r2, #1
	add r4, r2		@ r4 zeigt jetzt auf pwm1 oder pwm2
	ldr r5, adrMesswerte
	add r5, r2,lsl#3	@ bei pwm2: 8 addieren fuer rechts
	ldr r3, [r5,#4]		@ Spannung
	cmp r1, r3
	bcc pwm_zuhoch
	ldr r3, [r5,#0]		@ Ladestrom
	add r0, #1		@ r0=Sollwert+1
	cmp r0, r3		@ Ladestrom > Sollwert+1 ?
	bcc pwm_zuhoch		@ ja-->
	add r3, #2		@ r3+2 statt r0-2
	cmp r3, r0		@ Ladestrom < Sollwert-1 ?
	bcs pwm_ret		@ nein--> ok
pwm_zuniedrig:
	ldrb r3, [r4]		@ zu niedriger pwm-Wert
	add r3, #1		@ erhoehen
	cmp r3, #96		@ auf Maximalwert beschraenken
	strccb r3, [r4]
	b pwm_ret
pwm_zuhoch:
	ldrb r3, [r4]		@ zu hoher pwm-Wert
	subs r3, #1		@ erniedrigen
	strcsb r3, [r4]		@ nur speichern wenn groesser gleich 0
pwm_ret:pop {r0,r2-r5,pc}

eventuell_pwm_regeln:	@ Eingabe: r10=Flags, 0x0F=links 0xF0=rechts, 1=Entladen, 2=Laden, 4=Erhaltung
			@ es soll nur geregelt werden wenn am Laden oder bei Erhaltungsladung
	push {r0-r3,lr}
	ldr r3, =uvoll
	tst r10, #0x06		@ pwm1 regeln?
	beq ev1			@ nein-->
	ldr r1, [r3]		@ uvoll
	tst r10, #2		@ im Ladezyklus?
	ldrne r0, [r3,#4]	@ ja: Ladestrom
	@addne r1, #50		@     ev. Umax etwas ueber uvoll
	ldreq r0, [r3,#8]	@ nein: Erhaltstrom
	subeq r1, #100		@       und Umax etwas unter uvoll
	mov r2, #0		@ pwm1
	bl pwm_regeln
ev1:	tst r10, #0x60		@ pwm2 regeln?
	beq ev2			@ nein-->
	ldr r1, [r3]		@ uvoll
	tst r10, #0x20		@ im Ladezyklus?
	ldrne r0, [r3,#4]	@ ja: Ladestrom
	@addne r1, #50		@     und Umax etwas ueber uvoll
	ldreq r0, [r3,#8]	@ nein: Erhaltstrom
	subeq r1, #100		@       und Umax etwas unter uvoll
	mov r2, #1		@ pwm2
	bl pwm_regeln
ev2:	pop {r0-r3,pc}

print_kapazitaet: @ Kapazitaet in mAsec oder mAh drucken
		  @ r3=Kapazitaet in mAsec, r0=x, r1=y
		  @ Rueckgabe: r0, r1 aktualisiert
	push {r2-r5,lr}
	cmp r3, #3600
	bcs kap_in_mAh
	bl printzahl
	bl print_mA
	bl print_sec
	b kap_ret
kap_in_mAh:
	mov r4, r0
	mov r5, r2
	mov r0, r3
	mov r2, #3600
	bl divu			@ Division: r0=r0/r2
	mov r3, r0
	mov r0, r4
	mov r2, r5
	bl printzahl
	bl print_mA
	mov r3, #'h'
	bl printchar
	mov r5, r0
	bl printblank
	bl printblank
	mov r0, r5
kap_ret:pop {r2-r5,pc}

print_mV:
	push {r3,lr}
	mov r3, #'m'
	bl printchar
	mov r3, #'V'
	bl printchar
	pop {r3,pc}

print_mA:
	push {r3,lr}
	mov r3, #'m'
	bl printchar
	mov r3, #'A'
	bl printchar
	pop {r3,pc}

print_sec:
	push {r3,lr}
	mov r3, #'s'
	bl printchar
	mov r3, #'e'
	bl printchar
	mov r3, #'c'
	bl printchar
	pop {r3,pc}

@ entspricht: printf("%s%d m%c\n",char* Text,int Zahl,char Einheit)
print_text_zahl: @ r3=Zeiger auf Text, r4=Zahl, r5=Einheit
	push {r2-r3,lr}
	bl printstring
	mov r2, #0	@ unformattiert
	mov r3, r4
	bl printzahl
	bl printblank
	mov r3, #'m'
	bl printchar
	mov r3, r5
	bl printchar	@ mV oder mA
	bl print_newline
	pop {r2-r3,pc}

@ ---------------------------------------------------------------------
@ Interrupts
	.data
Uhrdaten:
                          @ Adr Kommentar
	.word PWMFREQUENZ @ 0   Ticks, werden mit 10kHz runtergezaehlt
	.byte 0		  @ 4   Sekunden
	.byte 0 	  @ 5   Minuten
	.byte 0		  @ 6   Stunden
	.byte 0		  @ 7   Reserve
                          @ Adr Kommentar
endzeitpunkt: .word 0	  @ 8   Zeitpunkt wenn ein Ladetransistor gesetzt und Uhr aktualisiert wird
pwmzeitpunkt: .word 0	  @ 12  Zeitpunkt wenn der Ladetransistor wieder ausgeschaltet wird
pwm1:	.byte 12 	  @ 16  Werte von 0 bis 99 erlaubt (bei kleiner 5 ist es ganz aus)
pwm2:	.byte 12 	  @ 17  Werte von 0 bis 99 erlaubt (groesser 95 ist gleich wie 95)
pwmstatus: .byte 0	  @ 18  gerade aktiver PWM, 0=PWM1 (linker), 1=PWM2 (rechter Transistor)
	.byte 0		  @ 19  Reserve
pwmfreq:.word PWMFREQUENZ @ 20  PWM-Frequenz
	.text
adrUhrdaten:	.word Uhrdaten

@ ---------------------------
@ nur zum Debuggen gebraucht:
pwm_check:	@ ueberpruefen ob pwm noch korrekt laeuft
		@ Rueckgabewerte: r6=Zeitpunkt PWM
		@ wenn ok: r3=0 und Z=0, sonst r3=Zeitpunkt Timer,
        push {r0-r2,lr}
	ldr r2, adrUhrdaten
	ldr r3, [r2,#8]		@ Zeitpunkt fuer Timer
	ldr r6, [r2,#12]	@ Zeitpunkt fuer PWM
	cmp r3, r6		@ PWM > Timer ?
	bcc pwm_ok		@ ja --> ok
	sub r0, r3, r6		@ nein: r0=Differenz
	cmp r0, #100		@ Differenz >= 100
	bcc pwm_ok		@ nein --> ok
	tst r3,r3
	pop {r0-r2,pc}
pwm_ok:	movs r3, #0
	pop {r0-r2,pc}
pwm_restart:		@ nur zum Debuggen
        push {r0-r2,lr}
	ldr r2, adrUhrdaten
	mov r0, #0
	strb r0, [r2,#18]	@ pwmstatus=0
	ldrb r0, [r2,#16]	@ pwm1 aktiv
	bl pwmpause_set
	pop {r0-r2,pc}
@ ---------------------------
	
pause_set_start:
        push {r0-r2,lr}
	ldr r2, adrUhrdaten
        ldr r1, [r8,#4]		@ Zaehler des Timers einlesen, nur untere 32-Bit
	str r1, [r2,#8]		@ Endzeitpunkt speichern
	bl pause_set
	ldrb r0, [r2,#16]
	bl pwmpause_set
	pop {r0-r2,pc}

pause_set:	@ Parameter: r2=uhrdaten
		@ Rueckgabe: r1 zerstoert
        ldr r1, [r2,#8]		@ vorheriger Endzeitpunkt laden
	add r1, #(1000000/PWMFREQUENZ)	@ neuer Endzeitpunkt berechnen, 100us fuer 10kHz, 1000us fuer 1kHz
	str r1, [r2,#8]		@ Endzeitpunkt speichern
        str r1, [r8,#16]	@ speichern im Vergleichsregister "Compare 1"
        mov r1, #0b10		@ M1
        str r1, [r8,#0]		@ Bit M1 im CS ruecksetzen
	mov pc, lr

pwmpause_set:	@ Parameter: r0=PWM-Dauer, r2=uhrdaten
		@ Rueckgabe: r0-r1 zerstoert
.ifdef NUR1KHZ
	mov r1, #10	@test bei 1kHz mit 10 multiplizieren
	mul r0, r1	@test bei 1kHz mit 10 multiplizieren
	@ dann auch andere Minimal/Maximal-Werte
.endif
	cmp r0, #5		@ auf Minimalwert testen
	movcc r0, #5
	cmp r0, #95		@ auf Maximalwert testen
	movhi r0, #95
	ldr r1, [r2,#8]		@ endzeitpunkt laden
	add r1, r0		@ neuer pwmzeitpunkt berechnen
	str r1, [r2,#12]	@ pwmzeitpunkt speichern
	str r1, [r8,#24]	@ speichern im Vergleichsregister "Compare 3"
	mov r1, #0b1000		@ M3
	str r1, [r8,#0]		@ Bit M3 im CS ruecksetzen
	mov pc, lr

irq_routine:
	push {r0-r2,r7-r8,lr}
	ldr r8, =timer_adresse
	ldr r8, [r8]
	ldr r0, [r8,#0]
	and r0, #0b1010		@ nur M1 und M3 behalten
	cmp r0, #0b1010		@ beide gleichzeitig gesetzt?
	beq irq_spezialfall	@ ja-->
	tst r0, #0b1000		@ M3 gesetzt?
	bne irq_pwm		@ ja-->
	tst r0, #0b10		@ M1 gesetzt?
	bne irq_timer		@ ja-->
irq_taster:			@ nein: Taster-Interrupts
	@ noch zu machen
	b irq_ret
irq_spezialfall:	@ M1 und M3 gleichzeitig gesetzt
	ldr r2, adrUhrdaten
	ldr r0, [r2,#8]		@ endzeitpunkt
	ldr r1, [r2,#12]	@ pwmzeitpunkt
	and r7, r0, #(0xFF<<24)	@ sind wir in der Naehe des Wechsels von positiven zu negativen Zahlen?
	cmp r7, #(0x80<<24)
	bne irq_v	@ nein --> dann Vorzeichenbehaftet vergleichen
	cmp r1, r0	@ ja: Vergleich von Vorzeichenlosen Zahlen
	bhi irq_timer	@ wenn pwmzeitpunkt groesser --> irq_timer zuerst machen
	b irq_pwm	@ sonst irq_pwm zuerst
irq_v:	cmp r1, r0	@ Vergleich mit Vorzeichenbehafteten Zahlen
	bgt irq_timer	@ wenn pwmzeitpunkt groesser --> irq_timer zuerst machen
irq_timer:
	ldr r2, adrUhrdaten
	bl pause_set
	ldr r0, [r2]		@ Ticks
	subs r0, #1
	bne irq_1
	ldr r0, [r2,#20]	@ pwmfreq, Ticks wieder auf 10000 setzen bei 10kHz
	ldrb r1, [r2,#4]	@ Sekunden
	add r1, #1
	cmp r1, #60
	bne irq_2
	mov r1, #0		@ Sekunden wieder auf 0
	ldrb r7, [r2,#5]	@ Minuten
	add r7, #1
	cmp r7, #60
	bne irq_3
	ldrb r7, [r2,#6]	@ Stunden
	add r7, #1
	strb r7, [r2,#6]
	mov r7, #0		@ Minuten wieder auf 0
irq_3:	strb r7, [r2,#5]	@ Minuten speichern
irq_2:	strb r1, [r2,#4]	@ Sekunden speichern
irq_1:	str r0, [r2]		@ Ticks speichern
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	ldrb r1, [r2,#18]	@ pwmstatus
	tst r1, r1
	moveq r0, #(1<<GPIO_LADEN_L)	@ Linker Ladetransistor wenn pwmstatus==0
	movne r0, #(1<<GPIO_LADEN_R)	@ Rechter Ladetransistor wenn pwmstatus==1
	ldreqb r1, [r2,#16]		@ pwm1 oder
	ldrneb r1, [r2,#17]		@ pwm2 laden
	cmp r1, #5		@ mindestens Minimalwert?
	strcs r0, [r7,#28]	@ ja: Ladetransistor ein
irq_ret:pop {r0-r2,r7-r8,lr}
	subs pc, lr, #4		@ Ruecksprung vom Interrupt
irq_pwm:
	ldr r2, adrUhrdaten
	ldrb r1, [r2,#18]	@ pwmstatus
	eors r1, #1		@ Bit 0 umkehren
	strb r1, [r2,#18]	@ pwmstatus
	ldreqb r0, [r2,#16]	@ pwm1 fuer Links
	ldrneb r0, [r2,#17]	@ pwm2 fuer Rechts
	bl pwmpause_set
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	mov r1, #(1<<GPIO_LADEN_R)|(1<<GPIO_LADEN_L)
	str r1, [r7,#40]	@ beide Ladetransistoren aus
	pop {r0-r2,r7-r8,lr}
	subs pc, lr, #4		@ Ruecksprung vom Interrupt

adr_irq_routine:
	.word irq_routine

irq_init:	@ Rueckgabe wenn erfolgreich: r0=0
	push {r1-r2,lr}
	mrs r0, cpsr            @ aktueller Modus in r0 sichern
	mov r1, #0xD2           @ in IRQ-Modus schalten
        msr cpsr_ctl, r1
        mov sp, #0x6000         @ Stack Pointer fuer IRQ-Modus setzen
        msr cpsr_ctl, r0        @ in vorherigen Modus zurueck
	mov r2, #0x18		@ Adresse des irq-Interrupt-Vectors
	ldr r1, adr_irq_routine	@ Adresse der irq_routine
	sub r1, r2
	sub r1, #8		@ Berechung der Sprungdistanz
	lsr r1, #2		@ Dividieren durch 4 fuer Distanz in 4-Byte-Worten
	add r1, #0xEA000000	@ Code des Sprungbefehls addieren
	str r1, [r2]		@ irq-Interrupt-Vector setzen
	@ Flags zum IRQ erlauben setzen, im CPSR und im Interrupt-Controller:
	mrs r0, cpsr
	bic r0, #0x80		@ IRQ-Disable auf 0 setzen
	msr cpsr_ctl, r0
	@mov r0, #(1<<1)	@ IRQ 1 erlauben fuer Systemtimer Compare1
	@str r0, [r9,#0x210]	@ in "Enable IRQs 1" entsprechendes Bit setzen
	mov r0, #(1<<1)|(1<<3)	@ IRQ 1 und IRQ 3 erlauben fuer Systemtimer Compare1 und Compare3
	str r0, [r9,#0x210]	@ in "Enable IRQs 1" entsprechende Bits setzen
	ldr r0, [r2]		@ irq-Vector nochmals lesen
	sub r0, r1		@ vergleichen mit was es sein sollte
	pop {r1-r2,pc}

@ ---------------------------------------------------------------------
@ AD-Wandler mit MCP3208
@
@ Um den AD-Wandler anzusprechen muss CS auf Low gesetzt werden.
@ Auf CLK werden dann ... positive Pulse gesendet mit jeweils
@ mindestens 250ns High und 250ns Low.
@ Dabei wird gleichzeitig etwas ueber DIN geschickt, und ueber DOUT
@ das Resultat eingelesen.

.equ AD_CS, 8
.equ CLK, 11
.equ DIN, 10
.equ DOUT, 9

	.data
referenzspannung:
	.word 2457	@ Uref in mV (ausgemessen)
	.text

clkpause:	@ mindestens 250ns warten, besser etwas mehr (maximal 50us)
	push {r0,lr}
	mov r0, #1
	bl microwait
	pop {r0,pc}

bit_ausgeben:	@ Eingabe: r4 untere 5 Bits
		@ Rueckgabe: r4 = (r4<<1)
	push {r0-r1,lr}
	mov r1, r4,lsr#4
	mov r0, #DIN
	bl gpio_ein_aus
	lsl r4, #1
	pop {r0-r1,pc}

bit_einlesen:	@ Eingabe: r3=bisheriges Resultat, r6=Startflag, r7=GPIO-Adresse
		@ Rueckgabe: r3, r6 = aktualisierte Werte
	push {r0,lr}
	ldr r0, [R7,#0x34]	@ GPIO-Inputs
	lsr r0, #DOUT
	and r0, #1
@ Test auf Startbit nicht noetig wenn wir am Ende nur unterste 12 Bits behalten
@	tst r6, #1	@ Startflag schon gesetzt?
@	bne be1		@ ja-->
@	tst r0, #1	@ nein: wurde Nullbit als Start empfangen?
@	moveq r6, #1	@ ja: Startflag setzen
@	b be2
be1:	lsl r3, #1
	add r3, r0	@ Bit im Resultat anfuegen
be2:	pop {r0,pc}

adwandlung: @ Eingabe: r0=Kanal (0...7), r1=Anzahl Aufsummierungen (nur 2^n erlaubt)
	    @ Rueckgabe: r3=Resultat
	push {r0-r2,r4-r7,r9-r10,lr}
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	orr r4, r0, #0x18  @ zu sendendes Kommando: Startbit+SGL+Kanal
	mov r2, r1
	mov r9, #0	@ r9 fuer Aufsummierungen
	mov r10, r2	@ r10 = Anzahl Aufsummierungen
ad_sum:	push {r4}
	mov r0, #AD_CS	@ CS fuer AD-Wandler (MCP3208)
	mov r1, #0
	bl gpio_ein_aus	@ CS auf Low
	mov r3, #0	@ Ergebnis vorbereiten
	mov r6, #0	@ Startflag fuer Empfang von Ergebnis
	mov r5, #19	@ 19 Bits senden/empfangen
	bl clkpause	@ Synchronisation von clkpause, eventuell nicht noetig
ad_1:	bl bit_ausgeben
	bl clkpause
	mov r0, #CLK
	mov r1, #1
	bl gpio_ein_aus	@ CLK auf High
	bl bit_einlesen
	bl clkpause
	mov r1, #0
	bl gpio_ein_aus	@ CLK auf Low
	subs r5, #1
	bne ad_1
	mov r0, #AD_CS
	mov r1, #1
	bl gpio_ein_aus	@ CS auf High
	bl clkpause	@ CS mindestens so lange auf High
	mov r0, #0xFF
	add r0, #0xF00	@ r0=0xFFF = unterste 12 Bits
	and r3, r0	@ r3=Resultat, nur unterste 12 Bits behalten
	pop {r4}
	add r9, r3	@ r9=Ausummiertes Resultat
	subs r2, #1
	blne warten_zwischen_wandlungen
	tst r2,r2
	bne ad_sum
ad_3:	lsrs r10, #1
	beq ad_4
	lsr r9, #1	@ Aufsummiertes dividieren
	b ad_3
ad_4:	mov r3, r9
	pop {r0-r2,r4-r7,r9-r10,pc}
warten_zwischen_wandlungen:
	push {r0,lr}
	mov r0,#50	@ ergibt eine Totalzeit pro Wandlung von etwa 135 us
	bl microwait
	pop {r0,lr}

messwert_in_spannung_umrechnen:	@ Eingabe: r3=Messwert (12 Bit)
				@ Rueckgabe: r3=Spannung in MilliVolt
	push {r2,lr}
	ldr r2, =referenzspannung
	ldr r2, [r2]
	mul r3, r2	@ U = Uref/4096*Messwert = Uref*Messwert/4096
	add r3, #2048	@ fuer korrekte Rundung
	lsr r3, #12	@ Division durch 4096
	pop {r2,pc}

strom_ausrechnen:
	@ Eingabe: r0=Widerstand in MilliOhm, r1=Spannung1, r2=Spannung2 in mV
	@ Rueckgabe: r3=Strom in MilliAmpere
	push {r2,r4,lr}		@ U=R*I, I=U/R
	subs r3, r1, r2		@ r3=r1-r2
	subcc r3, r2, r1	@ Absolutwert
	mov r2, #1000		@ Faktor 1000 damit wir MilliAmpere erhalten
	mul r2, r3
	mov r3, r0		@ 1000*mV dividieren durch mOhm ergibt mA
	add r2, r3,lsr#1	@ Halber Teiler addieren fuer korrekte Rundung
	bl divmod		@ Positive Zahlen dividieren: r2 /= r3, r4=Rest
	mov r3, r2
	pop {r2,r4,pc}

@ ---------------------------------------------------------------------
@ Divisionen

divu:	@ Positive Zahlen dividieren: r0 /= r2
	push {r1,r3,lr}
	mov r1, #0	@ Rest=0
	mov r3, #32	@ 32 Bits behandeln
divu1:	lsl r1, #1
	lsls r0, #1
	addcs r1, #1	@ Bits von r0 nach links ins r1 schieben
	cmp r1, r2	@ r1>=r2, Rest>=Teiler
	addcs r0, #1	@ ja: Resultat-Bit setzen
	subcs r1, r2	@ ja: und r2 von r1 Subtrahieren
	subs r3, #1	@ naechstes Bit
	bne divu1	@ Resultat ist jetzt in r0
	pop {r1,r3,pc}

divs:	@ Vorzeichenbehaftete Zahlen dividieren: r0 /= r2
	push {r1-r2,lr}
	mov r1, #0	@ Vorzeichenflag: 0=positiv, 1=negativ
	tst r0,r0	@ r0<0 ?
	eormi r1, #1	@ ja: Vorzeichenflag umkehren
	rsbmi r0,r0,#0	@     r0 = -r0
	tst r2,r2	@ r2<0 ?
	eormi r1, #1	@ ja: Vorzeichenflag umkehren
	rsbmi r2,r2,#0	@     r2 = -r2
	bl divu
	tst r1, #1	@ Vorzeichen negativ?
	rsbne r0,r0,#0	@ ja: Ergebnis negativ machen
	pop {r1-r2,pc}

divumod: @ Positive Zahlen dividieren: r0 /= r2, r1 = Rest
	push {r3,lr}
	mov r1, #0	@ Rest=0
	mov r3, #32	@ 32 Bits behandeln
divum1:	lsl r1, #1
	lsls r0, #1
	addcs r1, #1	@ Bits von r0 nach links ins r1 schieben
	cmp r1, r2	@ r1>=r2, Rest>=Teiler
	addcs r0, #1	@ ja: Resultat-Bit setzen
	subcs r1, r2	@ ja: und r2 von r1 Subtrahieren
	subs r3, #1	@ naechstes Bit
	bne divum1	@ Resultat ist jetzt in r0
	pop {r3,pc}	@ und Rest in r1

@ ---------------------------------------------------------------------
@ Grafik in einem definierten Bereich (Fenster)
@
	.data
FensterDaten:
	.word 0		@  #0 x0 Pixelposition unten links
	.word 1079	@  #4 y0 Pixelposition unten links
	.word 0		@  #8 x1 Userkoordinaten unten links
	.word 0		@ #12 y1 Userkoordinaten unten links
	.word 1919	@ #16 x2 Userkoordinaten oben rechts
	.word 1079	@ #20 y2 Userkoordinaten oben rechts
	.word 1920	@ #24 Breite in Pixel
	.word 1080	@ #28 Hoehe in Pixel
	.word 0		@ #32 xscale = 2^16*Breite/(x2-x1)
	.word 0		@ #36 yscale = 2^16*Hoehe/(y2-y1)
	.text
adrFensterDaten:	.word FensterDaten

grafik_setposition:	@ r0,r1 = x0,y0 Pixelwerte, r2=Breite, r3=Hoehe, r4=Zeiger auf FensterDaten
			@ muss als erstes aufgerufen werden um FensterDaten auszufuellen
	push {lr}
	str r0, [r4,#0]		@ x0 speichern
	str r1, [r4,#4]		@ y0
	str r2, [r4,#24]	@ Breite
	str r3, [r4,#28]	@ Hoehe
	pop {pc}

grafik_init:	@ r0,r1 = x1,y1 Userkoordinaten, r2,r3 = x2,y2 Userkoordinaten, r4=Zeiger auf FensterDaten
		@ zuvor grafik_setposition aufrufen um in FensterDaten Pixelwerte zu setzen
	push {r0-r2,lr}
	str r0, [r4,#8]		@ x1 speichern
	str r1, [r4,#12]	@ y1
	str r2, [r4,#16]	@ x2
	str r3, [r4,#20]	@ y2
	sub r2, r0		@ r2=x2-x1
	ldr r0, [r4,#24]
	lsl r0, #16		@ r0=Breite*2^16
	bl divu			@ Division: r0=r0/r2
	str r0, [r4,#32]	@ xscale = Breite*2^16/(x2-x1)
	sub r2, r3, r1		@ r2=y2-y1
	ldr r0, [r4,#28]
	lsl r0, #16		@ r0=Hoehe*2^16
	bl divu
	str r0, [r4,#36]	@ yscale = Hoehe*2^16/(y2-y1)
	pop {r0-r2,pc}

grafik_punkt:	@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
		@ es wird der entsprechende Punkt gesetzt (im Normal-Modus, andere Moden noch nicht programmiert)
	push {r0-r1,r5,lr}
	ldr r5, [r4,#8]		@ x1
	subs r0, r5		@ x-x1
	bcc pu_ret		@ wenn x<x1 --> Fehler, kein Punkt setzen
	ldr r5, [r4,#32]
	mul r0, r5		@ xscal*(x-x1)
	add r0, #(1<<15)	@ zur korrekten Rundung
	lsr r0, #16		@ Division durch 2^16
	ldr r5, [r4,#24]	@ Breite
	cmp r0, r5		@ Groesser gleich Breite?
	bcs pu_ret		@ ja --> Fehler, kein Punkt setzen
	ldr r5, [r4,#0]
	add r0, r5		@ x0+xscal*(x-x1)/2^16
	ldr r5, [r4,#12]	@ y1
	subs r1, r5		@ y-y1
	bcc pu_ret		@ wenn y<y1 --> Fehler, kein Punkt setzen
	ldr r5, [r4,#36]
	mul r5, r1		@ yscal*(y-y1)
	add r5, #(1<<15)	@ zur korrekten Rundung
	lsr r5, #16		@ Division durch 2^16
	ldr r1, [r4,#28]	@ Hoehe
	cmp r5, r1		@ Groesser gleich Hoehe?
	bcs pu_ret		@ ja --> Fehler, kein Punkt setzen
	ldr r1, [r4,#4]
	sub r1, r5		@ y0-yscal*(y-y1)/2^16
	bl punkt_setzen
pu_ret:	pop {r0-r1,r5,pc}

grafik_clear:	@ r4=Zeiger auf FensterDaten, r2=Farbe
	push {r0,r1,r3,r5,lr}
	ldr r5, [r4,#4]		@ y0
	add r5, #1		@ r5=yGrenze = y0+1
	ldr r0, [r4,#28]	@ Hoehe
	sub r1, r5, r0		@ r1=y0+1-Hoehe
	ldr r0, [r4]		@ x0
	ldr r3, [r4,#24]	@ Breite
	add r3, r0		@ r3=xGrenze = x0+Breite
grcl_1:	ldr r0, [r4]		@ x0
grcl_2:	bl punkt_setzen		@ r0=x, r1=y, r2=Farbe
	add r0, #1
	cmp r0, r3
	bne grcl_2
	add r1, #1
	cmp r1, r5
	bne grcl_1
	pop {r0,r1,r3,r5,pc}
	
grafische_darstellung_init:  @ Darstellung fuer Entlade- und Lade-Kurven
			     @ Eingabe: r2=Farbe zum Loeschen oder -1 fuer ohne Loeschen
			     @          r3=Zeit in Stunden oder Minuten wenn negativ
	push {r0-r6,lr}
	mov r5, r2		@ r5=Loeschfarbe oder -1
	mov r6, #3600		@ Faktor zum von Stunden in Sekunden umrechnen
	tst r3,r3		@ r3 negativ?
	rsbmi r3, r3, #0	@ ja: Zeit in Minuten, r3 positiv machen
	movmi r6, #60		@     und Faktor auf 60 setzen
	mul r6, r3		@ r6=Zeit in Sekunden
	ldr r4, adrFensterDaten
	mov r0, #0		@ x0=0
	mov r1, #1000
	add r1, #79		@ y0=1079
	mov r2, #1920		@ Breite = Gesamte Bildschirmbreite
	mov r3, #540		@ Hoehe = ca. halbe Bildschirmhoehe
	bl grafik_setposition	@ r0,r1 = x0,y0 Pixelwerte, r2=Breite, r3=Hoehe, r4=Zeiger auf FensterDaten
	mov r0, #0
	mov r1, #0
	mov r2, r6		@ x2 = Zeit in Sekunden
	mov r3, #2000		@ y2 = 2000 mV
	bl grafik_init	@ r0,r1 = x1,y1 Userkoord., r2,r3 = x2,y2 Userkoord., r4=Zeiger auf FensterDaten
	mov r2, r5
	cmn r2, #1		@ Loeschfarbe == -1 ?
	blne grafik_clear	@ nein: Grafikbereich loschen
	pop {r0-r6,pc}

grafische_darstellung:	@ Eingabe: r4=Zeiger auf uhrdaten, r6=Zeiger auf Messwerte
	push {r0-r4,lr}
g1:	ldrb r3, [r4,#4]	@ Sekunden, aktuelle Zeit einlesen
	ldrb r1, [r4,#5]	@ Minuten
	ldrb r0, [r4,#6]	@ Stunden
	ldrb r2, [r4,#4]	@ Sekunden
	cmp r2, r3
	bne g1			@ nochmals falls Sekunden gerade geaendert haben
	mov r3, #60
	mul r0, r3		@ Stunden*60
	add r0, r1
	mul r0, r3		@ (Stunden*60+Minuten)*60
	add r0, r2		@ x = Zeit in Sekunden
	ldr r4, adrFensterDaten
	ldr r2, [r4,#16]	@ x2
	cmp r2, r0		@ x>x2 ?
	blcc grafische_darstellung_xzoomout	@ ja: Bereich erhoehen und bisheriges neue zeichnen
	ldr r1, [r6,#4]		@ Spannung links
	mov r2, #0
	bl daten_speichern
	mov r2, #0xFF00		@ Gruen
	mov r3, #0		@ Modus=Normal
	bl grafik_punkt		@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
	ldr r1, [r6,#12]	@ Spannung rechts
	mov r2, #1
	bl daten_speichern
	mov r2, #0xFF		@ Rot
	bl grafik_punkt		@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
	pop {r0-r4,pc}

grafische_darstellung_xzoomout:	@ Eingabe: r0=Anzahl bisherige Messwerte+1, r4=Zeiger auf FensterDaten
	push {r0-r3,r5,lr}
	sub r5, r0, #1		@ Anzahl bisherige Messwerte
	ldr r0, [r4,#16]	@ x2
	lsl r0, #1		@ xBereich verdoppeln
	cmp r0, #3600		@ kleiner als 3600?
	mvncc r2, #60-1		@ ja: Zeit in Minuten angeben (Division durch -60 ergibt Negatives Resultat)
	movcs r2, #3600		@ sonst Zeit in Stunden
	bl divs			@ Division mit Vorzeichen: r0=r0/r2
	mov r3, r0
	mov r2, #0		@ Farbe=schwarz
	bl grafische_darstellung_init	@ r2=Farbe zum loeschen oder -1, r3=xmax in Std oder in Min wenn negativ
	bl grafische_darstellung_neuzeichnen
	pop {r0-r3,r5,pc}

grafische_darstellung_neuzeichnen:	@ r5=Anzahl bisherige Messwerte
	push {r0-r4,r6-r7,lr}
	mov r6, r5		@ Anzahl bisherige Messwerte
	mov r7, #0xFF00		@ Gruen fuer ersten Durchlauf
	mov r3, #0		@ Modus=Normal
	mov r2, #0		@ Links
gnz1:	mov r4, #0		@ 0 fuer ersten Datenpunkt
	mov r0, #0		@ x=0
gnz2:	bl daten_auslesen	@ Rueckgabe: r1=y, r4=aktualisiert
	push {r2,r4}
	ldr r4, adrFensterDaten
	mov r2, r7		@ Farbe
	bl grafik_punkt
	pop {r2,r4}
	add r0, #1		@ x=x+1
	subs r6, #1
	bne gnz2
	mov r6, r5		@ Anzahl bisherige Messwerte
	mov r7, #0xFF		@ Rot fuer 2. Durchlauf
	add r2, #1		@ Rechts beim 2. Durchlauf
	cmp r2, #2
	bne gnz1
	pop {r0-r4,r6-r7,pc}

@ ---------------------------------------------------------------------
@ Daten speichern
@
.equ SPSIZE, 40000  @ Speichergroesse in 4-Byte-Worten

daten_speichern:  @ Eingabe: r1=zu speichernder Wert, r2=Links/Rechts (0=Links, 1=Rechter Akku)
	push {r2,r4-r5,lr}
	ldr r5, adrDatengrab
	and r2, #1
	add r5, r2,lsl#2	@ r5 = Zeiger auf Zeiger auf Links- oder Rechts-Werte
	ldr r4, [r5]		@ r4 = Zeiger auf Links- oder Rechts-Werte
	ldr r2, [r5,#8]		@ r2 = Zeiger auf Speicherende (Links oder Rechts)
	cmp r4, r2		@ Speicherende erreicht?
	strne r1, [r4],#4	@ Daten speichern mit postincrement
	strne r4, [r5]		@ Zeiger speichern
	pop {r2,r4-r5,pc}

daten_auslesen:	 @ Eingabe: r2=Links/Rechts (0=Links, 1=Rechter Akku), r4=Zeiger oder 0 fuer ersten Wert
		 @ Rueckgabe: r1=Wert, r4=aktualisierter Zeiger
	push {lr}
	teq r4,#0
	bne da1
	tst r2, #1
	ldreq r4, adrDatenL
	ldrne r4, adrDatenR	@ r4 = Zeiger auf Zeiger auf Anfang Links- oder Rechts-Werte
da1:	ldr r1, [r4],#4		@ Daten mit Postincrement lesen
	pop {pc}

get_datengrab_groesse:	@ Rueckgabe: r0=Groesse in Bytes
	push {r1,lr}
	ldr r1, adrDatengrab
	ldr r0, adrDaten_end
	sub r0, r1
	pop {r1,pc}
	
	.data
Datengrab:	@ dies sollte ganz am Schluss des Programms stehen
	.word DatenL	@  0  Zeiger auf Links-Werte
	.word DatenR	@  4  Zeiger auf Rechts-Werte
	.word DatenR	@  8  Zeiger auf Speicherende Links
	.word Daten_end @ 12  Zeiger auf Speicherende Rechts
DatenL:	.skip 4*SPSIZE	@ Platz fuer 40000 4-Byte-Worte, zum 10 Std jede Sek speichern
DatenR:	.skip 4*SPSIZE	@ Platz fuer 40000 4-Byte-Worte, zum 10 Std jede Sek speichern
Daten_end: .word 0
	.text
adrDatengrab:	.word Datengrab
adrDatenL:	.word DatenL	@ Startadresse von Werten fuer Linken Akku
adrDatenR:	.word DatenR	@ Startadresse von Werten fuer Rechten Akku
adrDaten_end:	.word Daten_end

@ Ende des Programms
@ ---------------------------------------------------------------------
