@ raspiakkulader.s   letzte Aenderung: 2.5.2015
@ Laden von kleinen NiZn-Akkus und eines NiMH-Akkus mit bis zu 12 Zellen
@ Schaltung: raspiakkulader2.png
@ Es wird der 12Bit-AD-Wandler MCP3208 verwendet.
@ Es koennen 3 Akkus unabhaengig voneinander entladen und geladen werden.
	
@ Autor: Rolf Pfister
@ Copyright: OpenSource Freeware
@ Version: 0.1

@ Variante fuer Auswahl zwischen Linux und "bare-metal": (geht bisher nur mit bare-metal)
@.equ LINUX_VERSION, 1  @ auskommentieren fuer "bare-metal"
.include "anfang.s"
	b hauptprogramm
.include "raspisammlung.s"
@ Problem wenn Programm zu gross: invalid literal constant: pool needs to be closer
@ Vermeidung des Problems: "ldr rx, =Name" ersetzen

@ -----------------------------------------------------------------
@ Tests zum debuggen, in endgueltigem Programm alle auskommentieren
@.equ TRANSTEST, 1	@ Testen der Transistoren
@.equ UHRTEST, 1 	@ Testen der Interrupt-Uhr und PWM
@.equ ADTEST, 1		@ AD-Wandler testen
@ -----------------------------------------------------------------

@ GPIO-Nummern:
.equ GPIO_LADEN_L, 17	@ NiZn-Akkus (oder andere bis ca.2V)
.equ GPIO_ENTLAD_L, 18
.equ GPIO_LADEN_R, 22
.equ GPIO_ENTLAD_R, 27
.equ GPIO_LADEN_H, 24	@ Hochvolt-Akku (bis ca.15V mit externem 18V-Netzteil)
.equ GPIO_ENTLAD_H, 23

.equ PWMFREQUENZ, 10000  @ 10kHz PWM-Frequenz (weitere Aenderungen noetig bei anderen Werten)

@ ---------------------------------------------------------------------
@ GPIO
gpio_init:
	push {r0-r1,lr}
	mov r1, #1	@ als Ausgang schalten:
	mov r0, #GPIO_LADEN_L	@ GPIO17, laden links
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_L	@ GPIO18, entladen links
	bl gpio_init1
	mov r0, #GPIO_LADEN_R	@ GPIO22, laden rechts
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_R	@ GPIO27, entladen rechts
	bl gpio_init1
	mov r0, #GPIO_LADEN_H	@ laden Hochvolt
	bl gpio_init1
	mov r0, #GPIO_ENTLAD_H	@ entladen Hochvolt
	bl gpio_init1
	mov r0, #8	@ GPIO08, CS fuer AD-Wandler (MCP3208)
	bl gpio_init1
	bl gpio_ein_aus	@ CS auf High setzen fuer inaktiv
	mov r0, #11	@ GPIO11, CLK fuer AD-Wandler
	bl gpio_init1
	mov r0, #10	@ GPIO10, DIN fuer AD-Wandler
	bl gpio_init1
	mov r1, #0	@ als Eingang schalten:
	mov r0, #9	@ GPIO09, DOUT von AD-Wandler
	bl gpio_init1
	pop {r0-r1,pc}

entladetransistoren_einschalten:  @ Eingabe: r4=uhrdaten
	push {r0-r1,lr}
	mov r0, #0
	strb r0, [r4,#16]	@ pwm1 ausschalten
	strb r0, [r4,#17]	@ pwm2 ausschalten
	mov r1, #1
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	pop {r0-r1,pc}

entladetransistorH_ein:  @ Eingabe: r4=uhrdaten
	push {r0-r1,lr}
	mov r0, #0
	strb r0, [r4,#18]	@ pwm3 ausschalten
	mov r1, #1
	mov r0, #GPIO_ENTLAD_H
	bl gpio_ein_aus
	pop {r0-r1,pc}

@ --------------------------------------------------------------------------------------------
alle_spannungen_messen:  @ Eingabe r6=Zeiger auf Messwerte
			 @ r10=Flags, 0x0F=links 0xF0=rechts, 0xF00=Hochvolt, 1=Entladen, 2=Laden, 4=Erhaltung
	push {r0-r3,lr}
	mov r0, #0		@ Kanal 0, obere Spannung links
	mov r1, #256		@ Anzahl Aufsummierungen
	bl adwandlung		@ r3=Resultat
	bl messwert_in_spannung_umrechnen	@ r3=Resultat in mV
	mov r2, r3
	mov r0, #1		@ Kanal 1, Akku-Spannung links
	bl adwandlung
	bl messwert_in_spannung_umrechnen
	str r3, [r6,#4]		@ Spannung links
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	mov r1, r3
	bl strom_ausrechnen	@ r3=Resultat in mA
	str r3, [r6,#0]		@ Ladestrom links
	mov r0, #2		@ Kanal 2, obere Spannung rechts
	mov r1, #256		@ Anzahl Aufsummierungen
	bl adwandlung		@ r3=Resultat
	bl messwert_in_spannung_umrechnen	@ r3=Resultat in mV
	mov r2, r3
	mov r0, #3		@ Kanal 3, Akku-Spannung rechts
	bl adwandlung
	bl messwert_in_spannung_umrechnen
	str r3, [r6,#12]	@ Spannung rechts
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	mov r1, r3
	bl strom_ausrechnen	@ r3=Resultat in mA
	str r3, [r6,#8]		@ Ladestrom rechts
	mov r0, #9472
	add r0, #28		@ 9500 mOhm Entlade-Widerstand (2.5+6.8+0.2 Ohm)
	ldr r1, [r6,#4]		@ Spannung links
	mov r2, #0
	bl strom_ausrechnen
	str r3, [r6,#16]	@ Entladestrom links falls Entladezyklus
	ldr r1, [r6,#12]	@ Spannung rechts
	bl strom_ausrechnen
	str r3, [r6,#20]	@ Entladestrom rechts falls Entladezyklus
	tst r10, #1		@ Entlade links ?
	beq alsp1		@ nein-->
	ldr r0, [r6,#24]	@ Entladekap links
	ldr r3, [r6,#16]	@ Entladestrom links
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#24]
alsp1:	tst r10, #0x10		@ Entlade rechts ?
	beq alsp2		@ nein-->
	ldr r0, [r6,#28]	@ Entladekap rechts
	ldr r3, [r6,#20]	@ Entladestrom rechts
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#28]
alsp2:	tst r10, #2		@ Laden links ?
	beq alsp3		@ nein-->
	ldr r0, [r6,#32]	@ Ladekap links
	ldr r3, [r6,#0]		@ Ladestrom links
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#32]
alsp3:	
	tst r10, #0x20		@ Laden rechts ?
	beq alsp4		@ nein-->
	ldr r0, [r6,#36]	@ Ladekap rechts
	ldr r3, [r6,#8]		@ Ladestrom rechts
	add r0, r3		@ Kapazitaet in mAsec
	str r0, [r6,#36]
alsp4:
	mov r0, #4		@ Kanal 4, Spannung vom Hochvolt-Akku ueber 20k/2.2k gemessen
	mov r1, #32		@ Anzahl Aufsummierungen
	bl adwandlung		@ r3=Resultat
	bl messwert_in_spannung_umrechnen	@ r3=Resultat in mV
	@ Umrechnung wegen Spannungsteiler 20k + 2.2k
	mov r2, #2560
	add r2, #23		@ r3*22.2/2.2 = r3*22.2*256/2.2/256 = r3*2583/256
	mul r3, r2
	add r3, #128		@ zur korrekten Rundung
	lsr r3, #8		@ Division durch 256, r3 ist jetzt in mV des Hochvolt-Akkus
	tst r10, #0x100		@ Entlademodus?
	addne r0, r3, #400	@ ja: Spannungsabfall an Schottky-Diode korrigieren (provi. noch nachmessen)
	moveq r0, r3		@ nein: unkorrigierte Spannung
	str r0, [r6,#44]	@ Spannung Hochvolt
	tst r10, #0x100		@ Entlademodus?
	beq alsp5		@ nein-->
	mov r2, #112		@ r2 = Entladewiderstand in Zehntel-Ohm
	mov r0, #10
	mul r0, r3		@ Spannung in Zehntel-mV
	bl divu			@ r0=r0/r2, I=U/R ergibt Strom in mA
	mov r3, #0		@ kein Ladestrom
	b alsp6
alsp5:	mov r0, #5		@ Kanal 5 zum Ladestrom messen
	mov r1, #32		@ Aufsummierungen
	bl adwandlung		@ r3=Resultat
	bl messwert_in_spannung_umrechnen	@ r3=Resultat in mV, mit 1 Ohm Widerstand: mA
	ldr r0, [r6,#44]
	sub r0, r3		@ gemessene Spannung noch korrigieren wegen Spannungsabfall ueber Strommesswiderstand
	str r0, [r6,#44]
	mov r0, #0		@ kein Entladestrom
alsp6:	str r3, [r6,#40]	@ Ladestrom Hochvolt
	str r0, [r6,#48]	@ Entladestrom Hochvolt
	tst r10, #0x100		@ Entlademodus?
	beq alsp7		@ nein-->
	ldr r2, [r6,#52]	@ Entladekap H
	add r2, r0		@ Kapazitaet in mAsec
	str r2, [r6,#52]
alsp7:	tst r10, #0x200		@ Lademodus?
	beq alsp8		@ nein-->
	ldr r2, [r6,#56]	@ Ladekap H
	add r2, r3		@ Kapazitaet in mAsec
	str r2, [r6,#56]
alsp8:	
	pop {r0-r3,pc}

akku_erkennen:	@ Rueckgabe: r2: 0=keiner erkannt, 1=NiZn, 2=NiMH, 6= 6NiMH, 12= 12NiMH-Zellen
	push {r0-r1,r6,lr}
	ldr r6, adrMesswerte
	bl alle_spannungen_messen	@ provi. eigentlich sollte zuvor noch Erhaltungsladung eingeschaltet werden
	ldr r0, [r6,#44]	@ Spannung Hochvolt
	cmp r0, #9600		@ r0 > Mindestspannung von 12-Zellen-Akku?
	movcs r2, #12		@ ja: r2=12
	bcs akku_ret		@ ja: --> fertig
	cmp r0, #4800		@ Mindestspannung von 6-Zellen-Akku
	movcs r2, #6
	bcs akku_ret
	mov r2, #0
	ldr r0, [r6,#4]		@ Spannung Linker Akku
	cmp r0, #1296		@ Mindestspannung NiZn
	bcs akku_evnizn
	cmp r0, #800		@ Mindestspannung NiMH
	bcs akku_nimh
	ldr r0, [r6,#12]	@ Spannung Rechter Akku
	cmp r0, #1296		@ Mindestspannung NiZn
	bcs akku_evnizn
	cmp r0, #800		@ Mindestspannung NiMH
	bcc akku_ret
akku_nimh:
	mov r2, #2
	b akku_ret
akku_evnizn:
	cmp r0, #2000	@ zu hohe Spannung
	movcc r2, #1	@ nein: NiZn erkannt
akku_ret:
	pop {r0-r1,r6,pc}

@ ---------------------------------------------------------------------
@ Daten-Strukturen
	.data
gpio_adresse:	.word	0
timer_adresse:	.word	0
starttext: .string "Akkulader fuer NiZn u. NiMH Akkus (bis 12NiMH-Zellen, fast ca.15V)"
	.align
starttext1: .string "kein Akku erkannt   "
	.align
starttext2: .string "Akku erkannt: NiZn  "
	.align
starttext3: .string "Akku erkannt: NiMH  "
	.align
starttext4: .string "Akku erkannt: 6NiMH "
	.align
starttext5: .string "Akku erkannt: 12NiMH"
	.align
AkkudatenNiZn:
unorm:	.word 1600	@  0  Normale Spannung eines Akkus in mV
uleer:	.word 1300	@  4  Spannung wenn entladen
uvoll:	.word 1900	@  8  Spannung wenn voll geladen
ladestrom: .word 110	@ 12  Ladestrom in mA (fuer 550mAh Akkus)
erhaltstrom: .word 18	@ 16  Ladestrom fuer Erhaltungsladung
vollkap:.word 550*3600	@ 20  Volle Kapazitaet eines Akkus (in mAsec)

AkkudatenNiMH:
	.word 1200	@  0  Normale Spannung eines Akkus in mV
	.word 800	@  4  Spannung wenn entladen
	.word 1450	@  8  Spannung wenn voll geladen
	.word 400	@ 12  Ladestrom in mA (fuer 2000mAh Akku)
	.word 40	@ 16  Ladestrom fuer Erhaltungsladung
	.word 2000*3600	@ 20  Volle Kapazitaet eines Akkus (in mAsec)

Akkudaten6NiMH:
	.word 7200	@  0  Normale Spannung eines Akkus in mV
	.word 4800	@  4  Spannung wenn entladen
	.word 8700	@  8  Spannung wenn voll geladen
	.word 500	@ 12  Ladestrom in mA (fuer 2500mAh Akku)
	.word 50	@ 16  Ladestrom fuer Erhaltungsladung
	.word 2500*3600	@ 20  Volle Kapazitaet eines Akkus (in mAsec)

Akkudaten12NiMH:
	.word 14400	@  0  Normale Spannung eines Akkus in mV
	.word 9600	@  4  Spannung wenn entladen
	.word 17400	@  8  Spannung wenn voll geladen
	.word 500	@ 12  Ladestrom in mA (fuer 2500mAh Akku)
	.word 50	@ 16  Ladestrom fuer Erhaltungsladung
	.word 2500*3600	@ 20  Volle Kapazitaet eines Akkus (in mAsec)

Messwerte:	@ wird von "alle_spannungen_messen" ausgefuellt
	.word 0		@  0  Ladestrom links
	.word 0		@  4  Spannung links
	.word 0		@  8  Ladestrom rechts
	.word 0		@ 12  Spannung rechts
	.word 0		@ 16  Entladestrom links
	.word 0		@ 20  Entladestrom rechts
	.word 0		@ 24  Entladekapazitaet links
	.word 0		@ 28  Entladekapazitaet rechts
	.word 0		@ 32  Ladekapazitaet links
	.word 0		@ 36  Ladekapazitaet rechts
	.word 0		@ 40  Ladestrom Hochvolt
	.word 0		@ 44  Spannung Hochvolt
	.word 0		@ 48  Entladestrom Hochvolt
	.word 0		@ 52  Entladekapazitaet Hochvolt
	.word 0		@ 56  Ladekapazitaet Hochvolt
	.text
adr_gpio_adresse:	.word gpio_adresse
adr_timer_adresse:	.word timer_adresse
adrAkkudatenNiZn:	.word AkkudatenNiZn
adrAkkudatenNiMH:	.word AkkudatenNiMH
adrAkkudaten6NiMH:	.word Akkudaten6NiMH
adrAkkudaten12NiMH:	.word Akkudaten12NiMH
adrMesswerte:		.word Messwerte

hauptprogramm:	@ r7=GPIO-Adresse, r8=Timer-Basisadresse
	ldr r4, adr_gpio_adresse
	str r7, [r4]
	ldr r4, adr_timer_adresse
	str r8, [r4]
	bl gpio_init
	bl InitFrameBuffer
	tst r0,r0
	beq halt		@ bei Fehler anhalten
	mov r0, #0		@ Farbe=schwarz
	bl clearscreen		@ Bildschirm loeschen
	mov r0, #0		@ x-Koordinaten
	mov r1, #36		@ y-Koordinaten
	mov r0, #2		@ groesserer Text
	bl setfontscale
	ldr r3, =starttext
	bl printstring
	bl print_newline

@ Interrupts initialisieren fuer Uhr und PWM:
	bl pause_set_start
	bl irq_init
	tst r0, r0
	beq irq_init_erfolgreich
	.data
fehler1:.string "Fehler bei irq_init"
	.align
	.text
	ldr r3, =fehler1
	mov r0, #0
	bl printstring
	b halt
irq_init_erfolgreich:
/*
	.data
test1:	.string "irq_init erfolgreich"
	.align
	.text
	ldr r3, =test1
	mov r0, #0
	bl printstring
*/
	bl akku_erkennen	@ Rueckgabe: r2: 0=keiner erkannt, 1=NiZn, 6= 6NiMH, 12= 12NiMH-Zellen
	cmp r2, #6
	ldreq r6, adrAkkudaten6NiMH
	ldreq r3, =starttext4
	cmp r2, #12
	ldreq r6, adrAkkudaten12NiMH
	ldreq r3, =starttext5
	cmp r2, #2
	ldreq r6, adrAkkudatenNiMH
	ldreq r3, =starttext3
	cmp r2, #1
	ldreq r6, adrAkkudatenNiZn
	ldreq r3, =starttext2
	ldrcc r3, =starttext1		@ kein Akku erkannt
	ldrcc r6, adrAkkudatenNiZn	@ Default-Akku NiZn
	mov r12, r6		@ adrAkkudaten* des erkannten Akkus 
	bl printstring
	bl print_newline
	.data
text1:	.string "Normalspannung: "
	.align
	.text
	ldr r3, =text1
	ldr r4, [r6]
	mov r5, #'V'
	bl print_text_zahl
	.data
text2:	.string "Spannung wenn Leer: "
	.align
	.text
	ldr r3, =text2
	ldr r4, [r6,#4]
	bl print_text_zahl
	.data
text3:	.string "Endspannung beim Laden: "
	.align
	.text
	ldr r3, =text3
	ldr r4, [r6,#8]
	bl print_text_zahl
	.data
text4:	.string "Ladestrom: "
	.align
	.text
	ldr r3, =text4
	ldr r4, [r6,#12]
	mov r5, #'A'
	bl print_text_zahl
	.data
text5:	.string "Erhaltungsladung wenn voll: "
	.align
	.text
	ldr r3, =text5
	ldr r4, [r6,#16]
	bl print_text_zahl

/* nach weiter oben geschoben
@ Interrupts initialisieren fuer Uhr und PWM:
	bl pause_set_start
	bl irq_init
	tst r0, r0
	beq irq_init_erfolgreich
	.data
fehler1:.string "Fehler bei irq_init"
	.align
	.text
	ldr r3, =fehler1
	mov r0, #0
	bl printstring
	b halt
irq_init_erfolgreich:
	.data
test1:	.string "irq_init erfolgreich"
	.align
	.text
	ldr r3, =test1
	mov r0, #0
	bl printstring
*/

.ifdef TRANSTEST
@ Test der Transistoren ohne eingesetzte Akkus:
testloop:
	mov r1, #0	@ alle Transistoren ausschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #1	@ Transistoren einschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	b testloop
pause:	push {r0,lr}
	mov r0, #4000
	add r0, #1000
	bl milliwait	@ 5 Sekunden warten
	pop {r0,pc}
.endif @ TRANSTEST

.ifdef UHRTEST
@ Test der Interrupt-Uhr:
	.data
uhrtest:.string "Uhr testen:"
	.align
	.text
	ldr r3, =uhrtest
	bl printstring
	bl print_newline
	mov r5, #60
	ldr r4, adrUhrdaten
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5
	beq L1
	tst r3, #1	@ Test alle 2 Sekunden: PWM1 erniedrigen
	bleq pwm1_aendern
	tst r3, #0	@ Test alle 1 Sekunden: PWM2 erhoehen
	bleq pwm2_aendern
	mov r5, r3		@ r5=Sekunden
	ldrb r6, [r4,#5]	@ Minuten lesen
	ldrb r3, [r4,#6]	@ Stunden lesen
	mov r2, #2		@ Format: 2 Stellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r6
	add r2, #'0'<<24	@ Format: mit 0 auffuellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r5
	bl printzahl
	mov r2, #4		@ noch PWM1 und PWM2 drucken
	ldrb r3, [r4,#16]	@ pwm1
	bl printzahl
	ldrb r3, [r4,#17]	@ pwm2
	bl printzahl
	bl pwm_check	@ zum Debuggen
	beq L2		@ ok -->
	bl pwm_restart
	mov r2, #12
	bl printzahl	@ Zaehler Timer
	mov r3, r6
	bl printzahl	@ Zaehler PWM
	bl print_newline
L2:	mov r0, #0		@ wieder auf Zeilenanfang
	b L1

pwm2_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm2
	ldrb r0,[r2]
	add r0,#1
	b pwm1_1
pwm1_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm1
	ldrb r0,[r2]
	sub r0,#1
pwm1_1:	tst r0,r0		@ r0<0 ?
	addmi r0,#100		@ ja: 100 addieren
	cmp r0,#100		@ r0>=100 ?
	subcs r0,#100		@ ja: 100 subtrahieren
	strb r0,[r2]
	pop {r0,r2,pc}
.endif @ UHRTEST

.ifdef ADTEST
	.data
adtest:.string "AD-Wandler testen:"
	.align
	.text
	ldr r3, =adtest
	bl printstring
	bl print_newline
	ldr r4, adrUhrdaten
	ldr r6, adrMesswerte
	mov r5, #0	@ r5=Sekunden
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5		@ Sekunden geaendert?
	beq L1			@ nein--> warten
	mov r5, r3
	push {r0,r1}	@ x,y retten
	push {r0-r1}	@ x retten
	mov r0, #0	@ Kanal 0, Ladestrom links
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#0]
	mov r2, #6	@ Format "%6d"
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #1	@ Kanal 1, Akku-Spannung links
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#4]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #2	@ Kanal 2, Ladestrom rechts
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#8]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #3	@ Kanal 3, Akku-Spannung rechts
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#12]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	ldrb r3, [r4,#4]	@ Sekunden lesen
	bl printzahl
	bl print_newline	@ auf naechster Zeile in mV umgerechnete Werte
	ldr r3, [r6,#0]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#4]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#8]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#12]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	bl printblank
	bl printblank
	bl print_mV
	bl print_newline	@ auf naechster Zeile Lade-Stroeme anzeigen
	push {r0-r2}
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	ldr r1, [r6,#0]
	ldr r2, [r6,#4]
	bl strom_ausrechnen
	pop {r0-r2}
	bl printzahl		@ Strom links
	bl printblank
	bl print_mA
	bl printblank
	bl printblank
	push {r0-r2}
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	ldr r1, [r6,#8]
	ldr r2, [r6,#12]
	bl strom_ausrechnen
	pop {r0-r2}
	bl printzahl		@ Strom rechts
	bl printblank
	bl print_mA
	cmp r3, #18+10	@ Regelungsversuch auf 18 mA
	blcs zu_hoch
	cmp r3, #18-10	@ Regelungsversuch
	blcc zu_niedrig
	pop {r0,r1}	@ x,y zurueck
	b L1
zu_hoch:
	push {r0,lr}
	ldrb r0, [r4,#17]	@ pwm2
	subs r0, #1
	strcsb r0, [r4,#17]
	pop {r0,pc}
zu_niedrig:
	push {r0,lr}
	ldrb r0, [r4,#17]	@ pwm2
	add r0, #1
	cmp r0, #99
	strccb r0, [r4,#17]
	pop {r0,pc}

.endif @ ADTEST

@ Hauptprogramm Fortsetzung:
	.data
txtentlad1:	.string "Entladezyklus wird in 30 Sekunden gestartet"
	.align
txtentlad2:	.string "Entladezyklus gestartet                    "
	.align
txtladen:	.string "Ladezyklus gestartet                       "
	.align
txterhalt:	.string "Erhaltungsladung                           "
	.align
txtlinks:	.string "Linker Akku: "
	.align
txtrechts:	.string "Rechter Akku:"
	.align
txthochvolt:	.string "Hochvolt Akku:"
	.align
txtleer:	.string "             "
	.align
	.text
	bl print_newline
	mov r9, r1		@ r9=y-Position von erster Textzeile
	mov r10, #0		@ r10=Flags, 0x0F=links 0xF0=rechts, 1=Entladen, 2=Laden, 4=Erhaltung
	mov r11, #0		@ r11=Anzahl verlorene Sekunden (zum ueberpruefen ob Timing korrekt ist)
	ldr r3, =txtentlad1
	bl printstring
	bl print_newline
	ldr r4, adrUhrdaten
	ldr r6, adrMesswerte
	mov r5, #0		@ r5=Sekunden
	mvn r2, #0		@ r2= -1 (nicht loeschen)
	@mov r2, #0xFF0000	@ r2=Blau
	@mov r3, #1		@ xmax = 1 Stunde
	mvn r3, #30-1		@ xmax = 30 Minuten
	bl grafische_darstellung_init  @ r2=Farbe zum loeschen oder -1, r3=xmax in Std oder Min wenn negativ
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5		@ Sekunden geaendert?
	beq L1			@ nein--> warten

	@ Test auf verlorene Sekunden:
	add r5, #1		@ r5=berechnete neue Sekunde
	cmp r5, #60
	moveq r5, #0
	cmp r5, r3		@ stimmt es mit aktueller Sekunde ueberein?
	addne r11, #1		@ Nein: Anzahl verlorene Sekunden erhoehen
	blne print_verlorene_sekunden

	mov r5, r3
	push {r0-r1}		@ x,y Position sichern
	bl alle_spannungen_messen	@ unklar: falls besser im Warteloop muesste Kap-Messung rausgenommen werden
	bl eventuell_pwm_regeln	@ abhaengig von Flags in r10
	bl grafische_darstellung

	mov r3, #0
	bl zeile_mit_werten_anzeigen	@ r3=0 fuer linken Akku
	bl print_newline
	mov r3, #1
	bl zeile_mit_werten_anzeigen	@ r3=1 fuer rechten Akku
	bl print_newline
	mov r3, #2
	bl zeile_mit_werten_anzeigen	@ r3=2 fuer Hochvolt-Akku
	
	pop {r0-r1}		@ im naechsten Durchgang wieder selbe 3 Zeilen ueberschreiben
	tst r10,r10		@ falls Flags schon gesetzt, dann wurde schon begonnen
	bne L2
	cmp r5, #30		@ sonst nach 30 Sekunden Entladezyklus beginnen
	bne L1
	bl entladetransistoren_einschalten
	bl entladetransistorH_ein
	mov r10, #0x11		@ Entladeflags setzen
	add r10, #0x100		@ Entladeflag Hochvolt
	ldr r3, =txtentlad2
	bl meldung_auf_erste_zeile
	@bl testpause
	b L1
L2:	push {r0-r1}
	ldr r2, adrAkkudatenNiZn	@ provi.
	ldr r3, [r6,#4]		@ Spannung links
	tst r10, #0x01		@ Entladeflag fuer Links gesetzt?
	beq volltestL		@ nein-->
leertestL:
	ldr r1, [r2,#4]		@ uleer
	cmp r3, r1		@ Spannung < uleer ?
	blcc ladezyklus_links_starten	@ ja: Ladezyklus beginnen
	b leertestR
volltestL:
	ldr r1, [r2,#8]		@ uvoll
	sub r1, #100
	cmp r3, r1		@ Spannung >= uvoll-100mV ?
	bcc leertestR		@ nein--> noch nicht voll
	ldr r1, [r6,#32]	@ Ladekap links
	ldr r3, [r2,#20]	@ Vollkap
	cmp r3, r1		@ Ladekap > Vollkap ?
	blcc erhaltungszyklus_links	@ ja: Erhaltungsladung
leertestR:
	ldr r3, [r6,#12]	@ Spannung rechts
	tst r10, #0x10		@ Entladeflag fuer Rechts gesetzt?
	beq volltestR		@ nein-->
	ldr r1, [r2,#4]		@ uleer
	cmp r3, r1		@ Spannung < uleer ?
	blcc ladezyklus_rechts_starten	@ ja: Ladezyklus beginnen
	b leertestH
volltestR:
	ldr r1, [r2,#8]		@ uvoll
	sub r1, #100
	cmp r3, r1		@ Spannung >= uvoll-100mV ?
	bcc L3			@ nein--> noch nicht voll
	ldr r1, [r6,#36]	@ Ladekap rechts
	ldr r3, [r2,#20]	@ Vollkap
	cmp r3, r1		@ Ladekap > Vollkap ?
	blcc erhaltungszyklus_rechts	@ ja: Erhaltungsladung
leertestH:
	mov r2, r12		@ provi. adrAkkudaten6NiMH oder adrAkkudaten12NiMH
	ldr r3, [r6,#44]	@ Spannung Hochvolt
	tst r10, #0x100		@ Entladeflag fuer Hochvolt gesetzt?
	beq volltestH		@ nein-->
	ldr r1, [r2,#4]		@ uleer
	cmp r3, r1		@ Spannung < uleer ?
	blcc ladezyklus_hochvolt_starten	@ ja: Ladezyklus beginnen
	b L3
volltestH:
	ldr r1, [r2,#8]		@ uvoll
	sub r1, #600	@ provi.
	cmp r3, r1		@ Spannung >= uvoll-600mV ? (100mV pro Zelle)
	bcc L3			@ nein--> noch nicht voll
	ldr r1, [r6,#56]	@ Ladekap Hochvolt
	ldr r3, [r2,#20]	@ Vollkap
	cmp r3, r1		@ Ladekap > Vollkap ?
	blcc erhaltungszyklus_hochvolt	@ ja: Erhaltungsladung
L3:	pop {r0-r1}
	mov r3, #0x22
	add r3, #0x200
	tst r10, r3		@ mindestens eins der Ladeflags gesetzt?
	ldrne r3, =txtladen
	blne meldung_auf_erste_zeile
	mov r3, #0x44
	add r3, #0x400
	cmp r10, r3		@ alle Erhaltungslade-Flags gesetzt?
	ldreq r3, =txterhalt
	bleq meldung_auf_erste_zeile
	b L1

zeile_mit_werten_anzeigen:  @ r3 = 0 fuer Linker, 1 fuer rechter Akku, 2 fuer Hochvolt-Akku
			    @ r6=Zeiger auf Messwerte, r10=Flags
			    @ r0,r1 = x,y  wird entsprechend erhoeht
	push {r2-r4,r10,lr}
	mov r4, r3
	cmp r4, #1
	ldreq r3, =txtrechts
	ldrcc r3, =txtlinks
	cmp r4, #2
	ldreq r3, =txthochvolt
	bl printstring
	cmp r4, #1
	ldreq r3, [r6,#12]	@ Spannung rechts
	ldrcc r3, [r6,#4]	@ Spannung links
	cmp r4, #2
	ldreq r3, [r6,#44]	@ Spannung Hochvolt
	mov r2, #6
	bl printzahl
	bl printblank
	bl print_mV
	cmp r4, #0
	bne z1
	tst r10, #1
	ldrne r3, [r6,#16]	@ Entladestrom links
	ldreq r3, [r6,#0]	@ Ladestrom links
	b z3
z1:	cmp r4, #1
	bne z2
	lsr r10, #4
	tst r10, #1
	ldrne r3, [r6,#20]	@ Entladestrom rechts
	ldreq r3, [r6,#8]	@ Ladestrom rechts
	b z3
z2:	lsr r10, #8
	tst r10, #1
	ldrne r3, [r6,#48]	@ Entladestrom Hochvolt
	ldreq r3, [r6,#40]	@ Ladestrom Hochvolt
z3:	bl printzahl
	bl printblank
	bl print_mA
	cmp r4, #1
	ldrcc r3, [r6,#24]	@ Entladekap links
	ldreq r3, [r6,#28]	@ Entladekap rechts
	cmp r4, #2
	ldreq r3, [r6,#52]	@ Entladekap Hochvolt
	bl print_kapazitaet
	cmp r4, #1
	ldrcc r3, [r6,#32]	@ Ladekap links
	ldreq r3, [r6,#36]	@ Ladekap rechts
	cmp r4, #2
	ldreq r3, [r6,#56]	@ Ladekap Hochvolt
	tst r10, #6
	blne print_kapazitaet
	pop {r2-r4,r10,pc}

testpause:	@ zum Debuggen
	push {r0,lr}
	mov r0, #4000
	add r0, #1000
	bl milliwait	@ 5 Sekunden warten
	pop {r0,pc}

meldung_auf_erste_zeile:  @ Eingabe r3=Text
	push {lr}
	mov r1, r9		@ in erste Textzeile schreiben
	bl printstring
	bl print_newline
	pop {pc}

	.data
Verlorentxt:	.string	" Verlorene Sekunden:"
	.align
	.text
adrVerlorentxt:	.word Verlorentxt

print_verlorene_sekunden:  @ Eingabe: r11=Anzahl verlorene Sekunden, keine Reg veraendert
	push {r0-r3,lr}
	mov r1, r9		@ erste Zeile
	mov r0, #1088		@ etwas nach der Mitte der Zeile
	ldr r3, adrVerlorentxt
	bl printstring
	mov r3, r11
	mov r2, #3
	bl printzahl
	pop {r0-r3,pc}

ladezyklus_links_starten:
	push {r0-r1,lr}
	mov r1, #0		@ Entladetransistor ausschalten
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	bic r10, #0xF
	orr r10, #0x2		@ Ladeflag Links setzen
	mov r0, #20
	strb r0, [r4,#16]	@ pwm1 einschalten
	pop {r0-r1,pc}

ladezyklus_rechts_starten:
	push {r0-r1,lr}
	mov r1, #0		@ Entladetransistor ausschalten
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bic r10, #0xF0
	orr r10, #0x20		@ Ladeflag Rechts setzen
	mov r0, #20
	strb r0, [r4,#17]	@ pwm2 einschalten
	pop {r0-r1,pc}

ladezyklus_hochvolt_starten:
	push {r0-r1,lr}
	mov r1, #0		@ Entladetransistor ausschalten
	mov r0, #GPIO_ENTLAD_H
	bl gpio_ein_aus
	bic r10, #0xF00
	orr r10, #0x200		@ Ladeflag Rechts setzen
	mov r0, #20
	strb r0, [r4,#18]	@ pwm3 einschalten
	pop {r0-r1,pc}

erhaltungszyklus_links:
	push {r0,lr}
	bic r10, #0xF
	orr r10, #0x4		@ Erhaltungsflag Links setzen
	mov r0, #6		@ PWM-Wert fuer etwa 18 mA
	strb r0, [r4,#16]	@ pwm1 setzen
	pop {r0,pc}

erhaltungszyklus_rechts:
	push {r0,lr}
	bic r10, #0xF0
	orr r10, #0x40		@ Erhaltungsflag Rechts setzen
	mov r0, #6		@ PWM-Wert fuer etwa 18 mA
	strb r0, [r4,#17]	@ pwm2 setzen
	pop {r0,pc}

erhaltungszyklus_hochvolt:
	push {r0,lr}
	bic r10, #0xF00
	orr r10, #0x400		@ Erhaltungsflag Hochvolt setzen
	mov r0, #12		@ PWM-Wert fuer etwa 50 mA
	strb r0, [r4,#18]	@ pwm3 setzen
	pop {r0,pc}

halt:	b halt

pwm_regeln:  @ Eingabe: r0=Sollwert in mA, r1=Maxwert in mV, r2=pwm-Nr (0=pwm1, 1=pwm2, 2=pwm3, 3=pwm4)
	push {r0,r2-r5,lr}
	ldr r4, =pwm1
	and r2, #3
	add r4, r2		@ r4 zeigt jetzt auf pwm1, pwm2, pwm3 oder pwm4
	ldr r5, adrMesswerte	@ Zeiger auf Ladestrom links und Spannung links
	cmp r2, #1
	addeq r5, #8		@ bei pwm2: 8 addieren fuer rechts
	cmp r2, #2
	addeq r5, #40		@ bei pwm3: 40 addieren fuer Hochvolt
	ldr r3, [r5,#4]		@ Spannung
	cmp r2, #3		@ pwm4 ?
	beq pwm_ret		@ pwm4 noch nicht benutzt
	cmp r1, r3
	bcc pwm_zuhoch
	ldr r3, [r5,#0]		@ Ladestrom
	add r0, #1		@ r0=Sollwert+1
	cmp r0, r3		@ Ladestrom > Sollwert+1 ?
	bcc pwm_zuhoch		@ ja-->
	add r3, #2		@ r3+2 statt r0-2
	cmp r3, r0		@ Ladestrom < Sollwert-1 ?
	bcs pwm_ret		@ nein--> ok
pwm_zuniedrig:
	ldrb r3, [r4]		@ zu niedriger pwm-Wert
	add r3, #1		@ erhoehen
	cmp r3, #96		@ auf Maximalwert beschraenken
	strccb r3, [r4]
	b pwm_ret
pwm_zuhoch:
	ldrb r3, [r4]		@ zu hoher pwm-Wert
	subs r3, #1		@ erniedrigen
	strcsb r3, [r4]		@ nur speichern wenn groesser gleich 0
pwm_ret:pop {r0,r2-r5,pc}

eventuell_pwm_regeln:	@ Eingabe: r10=Flags, 0x0F=links 0xF0=rechts, 1=Entladen, 2=Laden, 4=Erhaltung
			@ es soll nur geregelt werden wenn am Laden oder bei Erhaltungsladung
	push {r0-r3,lr}
	ldr r3, adrAkkudatenNiZn
	tst r10, #0x06		@ pwm1 regeln?
	beq ev1			@ nein-->
	ldr r1, [r3,#8]		@ uvoll
	tst r10, #2		@ im Ladezyklus?
	ldrne r0, [r3,#12]	@ ja: Ladestrom
	ldreq r0, [r3,#16]	@ nein: Erhaltstrom
	subeq r1, #100		@       und Umax etwas unter uvoll
	mov r2, #0		@ pwm1
	bl pwm_regeln
ev1:	tst r10, #0x60		@ pwm2 regeln?
	beq ev2			@ nein-->
	ldr r1, [r3,#8]		@ uvoll
	tst r10, #0x20		@ im Ladezyklus?
	ldrne r0, [r3,#12]	@ ja: Ladestrom
	ldreq r0, [r3,#16]	@ nein: Erhaltstrom
	subeq r1, #100		@       und Umax etwas unter uvoll
	mov r2, #1		@ pwm2
	bl pwm_regeln
ev2:	tst r10, #0x600		@ pwm3 regeln?
	beq ev3			@ nein-->
	mov r3, r12		@ adrAkkudaten6NiMH	@ provi.
	ldr r1, [r3,#8]		@ uvoll
	tst r10, #0x200		@ im Ladezyklus?
	ldrne r0, [r3,#12]	@ ja: Ladestrom
	ldreq r0, [r3,#16]	@ nein: Erhaltstrom
	subeq r1, #600		@       und Umax etwas unter uvoll (provi. 6*100 fuer 6 Zellen)
	mov r2, #2		@ pwm3
	bl pwm_regeln
ev3:	pop {r0-r3,pc}

print_kapazitaet: @ Kapazitaet in mAsec oder mAh drucken
		  @ r3=Kapazitaet in mAsec, r0=x, r1=y
		  @ Rueckgabe: r0, r1 aktualisiert
	push {r2-r5,lr}
	cmp r3, #3600
	bcs kap_in_mAh
	bl printzahl
	bl print_mA
	bl print_sec
	b kap_ret
kap_in_mAh:
	mov r4, r0
	mov r5, r2
	mov r0, r3
	mov r2, #3600
	bl divu			@ Division: r0=r0/r2
	mov r3, r0
	mov r0, r4
	mov r2, r5
	bl printzahl
	bl print_mA
	mov r3, #'h'
	bl printchar
	mov r5, r0
	bl printblank
	bl printblank
	mov r0, r5
kap_ret:pop {r2-r5,pc}

print_mV:
	push {r3,lr}
	mov r3, #'m'
	bl printchar
	mov r3, #'V'
	bl printchar
	pop {r3,pc}

print_mA:
	push {r3,lr}
	mov r3, #'m'
	bl printchar
	mov r3, #'A'
	bl printchar
	pop {r3,pc}

print_sec:
	push {r3,lr}
	mov r3, #'s'
	bl printchar
	mov r3, #'e'
	bl printchar
	mov r3, #'c'
	bl printchar
	pop {r3,pc}

@ entspricht: printf("%s%d m%c\n",char* Text,int Zahl,char Einheit)
print_text_zahl: @ r3=Zeiger auf Text, r4=Zahl, r5=Einheit
	push {r2-r3,lr}
	bl printstring
	mov r2, #0	@ unformattiert
	mov r3, r4
	bl printzahl
	bl printblank
	mov r3, #'m'
	bl printchar
	mov r3, r5
	bl printchar	@ mV oder mA
	bl print_newline
	pop {r2-r3,pc}

@ ---------------------------------------------------------------------
@ Interrupts
	.data
Uhrdaten:
                          @ Adr Kommentar
	.word PWMFREQUENZ @ 0   Ticks, werden mit 10kHz runtergezaehlt
	.byte 0		  @ 4   Sekunden
	.byte 0 	  @ 5   Minuten
	.byte 0		  @ 6   Stunden
	.byte 0		  @ 7   Reserve
	.word 0		  @ 8   Reserve
	.word 0		  @ 12  Reserve
pwm1:	.byte 10	  @ 16  Werte von 0 bis 99 erlaubt (bei kleiner 5 ist es ganz aus)
pwm2:	.byte 10	  @ 17  Werte von 0 bis 99 erlaubt (groesser 95 ist gleich wie 95)
pwm3:	.byte 5 	  @ 18  Werte von 0 bis 99 erlaubt
pwm4:	.byte 0 	  @ 19  Werte von 0 bis 99 erlaubt
pwmfreq:.word PWMFREQUENZ @ 20  PWM-Frequenz
PWMvergleichswerte:
	.quad	0	  @ 24  64-Bit-Vergleichswert fuer Uhr
	.quad	0	  @ 32  Vergleichswert pwm1
	.quad	0	  @ 40  Vergleichswert pwm2
	.quad	0	  @ 48  Vergleichswert pwm3
	.quad	0	  @ 56  Vergleichswert pwm4
	.text
adrUhrdaten:	.word Uhrdaten

pause_set_start:	@ Parameter: r8=Timerbasisadresse
        push {r0-r3,lr}
	ldr r2, adrUhrdaten
	add r3, r8, #4
        ldm r3, {r0,r1}		@ 64-Bit Zaehler des Timers einlesen
	bl uhr_vergleichswert_berechnen
	str r0, [r8,#16]	@ speichern im Vergleichsregister "Compare 1"
	mov r1, #0b10		@ M1
	str r1, [r8,#0]		@ Bit M1 im CS ruecksetzen
	pop {r0-r3,pc}

uhr_vergleichswert_berechnen:	@ Parameter: r2=uhrdaten, r0,r1 = vorheriger Vergleichswert fuer Uhr
				@ Rueckgabe: r0,r1 = neuer Vergleichswert
	adds r0, #(1000000/PWMFREQUENZ)	@ neuer Vergleichswert berechnen, 100us fuer 10kHz, 1000us fuer 1kHz
	adc r1, #0
	str r0, [r2,#24]	@ neuer Vergleichswert speichern
	str r1, [r2,#28]	@ neuer Vergleichswert speichern
	mov pc, lr

pwm_vergleichswerte_berechnen:	@ Parameter: r2=Uhrdaten, r4,r5 = aktueller Timerwert
        push {r0-r3,lr}
	ldrb r0, [r2,#16]	@ pwm1
	cmp r0, #5		@ pwm1 < Minimalwert ?
	bcc pwm_v1		@ ja--> kein neuer Vergleichswert setzen
	cmp r0, #95		@ pwm1 > Maximalwert ?
	bcs pwm_v1		@ ja--> keine neuer Vergleichswert
	adds r0, r4
	adc r1, r5, #0
	add r3, r2, #32		@ r3=Zeiger auf Vergleichswert pwm2
	stm r3, {r0,r1}		@ neuer Vergleichswert pwm1 speichern
pwm_v1:	ldrb r0, [r2,#17]	@ pwm2
	cmp r0, #5		@ pwm2 < Minimalwert ?
	bcc pwm_v2		@ ja--> kein neuer Vergleichswert setzen
	cmp r0, #95		@ pwm2 > Maximalwert ?
	bcs pwm_v2		@ ja--> keine neuer Vergleichswert
	adds r0, r4
	adc r1, r5, #0
	add r3, r2, #40		@ Zeiger auf Vergleichswert pwm2
	stm r3, {r0,r1}		@ neuer Vergleichswert pwm2
pwm_v2:	ldrb r0, [r2,#18]	@ pwm3
	cmp r0, #5		@ pwm3 < Minimalwert ?
	bcc pwm_v3		@ ja--> kein neuer Vergleichswert setzen
	cmp r0, #95		@ pwm3 > Maximalwert ?
	bcs pwm_v3		@ ja--> keine neuer Vergleichswert
	adds r0, r4
	adc r1, r5, #0
	add r3, r2, #48		@ Zeiger auf Vergleichswert pwm3
	stm r3, {r0,r1}		@ neuer Vergleichswert pwm3
pwm_v3:	pop {r0-r3,pc}

naechster_vergleichswert_setzen:  @ kleinster Vergleichswert (Uhr oder einer der pwm) in "Compare 1" setzen
	@ Parameter: r4,r5 = aktueller Timerwert, r8=Timerbasisadresse, r2 = Uhrdaten
	@ Rueckgabe: r4,r5 = neuer aktueller Timerwert, Cy=gesetzt wenn naechster Vergleichswert bereits erreicht ist
        push {r0-r1,r6-r7,lr}
	ldr r6, [r2,#24]	@ Vergleichswert Uhr (unteres Word)
	ldr r7, [r2,#28]	@ Vergleichswert Uhr (oberes Word)
	ldr r0, [r2,#32]	@ Vergleichswert pwm1 (unteres Word)
	ldr r1, [r2,#36]	@ Vergleichswert pwm1 (oberes Word)
	cmp r5, r1
	cmpeq r4, r0		@ Vergleichswert groesser als aktueller Timerwert?  r0,r1 > r5,r4 ?
	bcs pwm_n1		@ nein-->
	cmp r1, r7
	cmpeq r0, r6		@ r0,r1 < r6,r7 ?
	movcc r6, r0		@ ja: bisher kleinster Wert kopieren (unteres Word)
	movcc r7, r1		@ ja: bisher kleinster Wert kopieren (oberes Word)
pwm_n1:	ldr r0, [r2,#40]	@ Vergleichswert pwm2
	ldr r1, [r2,#44]	@ Vergleichswert pwm2
	cmp r5, r1
	cmpeq r4, r0		@ groesser als aktueller Timerwert?
	bcs pwm_n2		@ nein-->
	cmp r1, r7
	cmpeq r0, r6		@ r0,r1 < r6,r7 ?
	movcc r6, r0		@ ja: bisher kleinster Wert kopieren
	movcc r7, r1		@ ja: bisher kleinster Wert kopieren
pwm_n2:	ldr r0, [r2,#48]	@ Vergleichswert pwm3
	ldr r1, [r2,#52]	@ Vergleichswert pwm3
	cmp r5, r1
	cmpeq r4, r0		@ groesser als aktueller Timerwert?
	bcs pwm_n3		@ nein-->
	cmp r1, r7
	cmpeq r0, r6		@ r0,r1 < r6,r7 ?
	movcc r6, r0		@ ja: bisher kleinster Wert kopieren
	movcc r7, r1		@ ja: bisher kleinster Wert kopieren
pwm_n3:	str r6, [r8,#16]	@ speichern im Vergleichsregister "Compare 1"
	mov r0, #0b10		@ M1
	str r0, [r8,#0]		@ Bit M1 im CS ruecksetzen
	add r0, r8, #4
	ldm r0, {r4,r5}		@ aktueller Timerwert nochmals lesen
	cmp r5, r7
	cmpeq r4, r6		@ ist Vergleichswert noch groesser? r6,r7 > r4,r5 ?
	pop {r0-r1,r6-r7,pc}	@ Ruckgabe: Cy gesetzt wenn Vergleichswert bereits erreicht

irq_routine:
	push {r0-r5,r7-r8,lr}
	ldr r8, adr_timer_adresse
	ldr r8, [r8]
	ldr r0, [r8,#0]
	tst r0, #0b10		@ M1 gesetzt?
	bne irq_timer		@ ja--> Timer und/oder PWM
irq_taster:			@ nein: Taster-Interrupts
	@ noch zu machen
	b irq_ret
irq_timer:
	add r3, r8, #4
	ldm r3, {r4,r5}		@ r4,r5 = aktueller Timerwert
	ldr r2, adrUhrdaten
	ldr r0, [r2,#24]
	ldr r1, [r2,#28]	@ r0,r1 = Vergleichswert Uhr
	subs r3, r4, r0
	sbcs r3, r5, r1		@ Vergleichswert > Timerwert ?
	bcc irq_pwm		@ ja--> Uhr muss noch nicht aktualisiert werden
	bl uhr_vergleichswert_berechnen
	ldr r0, [r2]		@ Ticks
	subs r0, #1
	bne irq_1
	ldr r0, [r2,#20]	@ pwmfreq, Ticks wieder auf 10000 setzen bei 10kHz
	ldrb r1, [r2,#4]	@ Sekunden
	add r1, #1
	cmp r1, #60
	bne irq_2
	mov r1, #0		@ Sekunden wieder auf 0
	ldrb r7, [r2,#5]	@ Minuten
	add r7, #1
	cmp r7, #60
	bne irq_3
	ldrb r7, [r2,#6]	@ Stunden
	add r7, #1
	strb r7, [r2,#6]
	mov r7, #0		@ Minuten wieder auf 0
irq_3:	strb r7, [r2,#5]	@ Minuten speichern
irq_2:	strb r1, [r2,#4]	@ Sekunden speichern
irq_1:	str r0, [r2]		@ Ticks speichern
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	ldrb r1, [r2,#16]	@ pwm1
	mov r0, #(1<<GPIO_LADEN_L)
	cmp r1, #5		@ mindestens Minimalwert?
	strcs r0, [r7,#28]	@ ja: Ladetransistor Links ein
	strcc r0, [r7,#40]	@ nein: Ladetransistor aus
	ldrb r1, [r2,#17]	@ pwm2
	mov r0, #(1<<GPIO_LADEN_R)
	cmp r1, #5		@ mindestens Minimalwert?
	strcs r0, [r7,#28]	@ ja: Ladetransistor Rechts ein
	strcc r0, [r7,#40]	@ nein: Ladetransistor aus
	ldrb r1, [r2,#18]	@ pwm3
	mov r0, #(1<<GPIO_LADEN_H)
	cmp r1, #5		@ mindestens Minimalwert?
	strcs r0, [r7,#28]	@ ja: Ladetransistor Hochvolt ein
	strcc r0, [r7,#40]	@ nein: Ladetransistor aus
	bl pwm_vergleichswerte_berechnen
irq_pwm:
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	add r3, r2, #32		@ Zeiger auf Vergleichswert pwm1
	ldm r3, {r0,r1}
	cmp r5, r1
	cmpeq r4, r0		@ Vergleichswert > Timerwert ?
	bcc irq_p1		@ ja--> noch nicht erreicht
	mov r1, #(1<<GPIO_LADEN_L)
	str r1, [r7,#40]	@ Ladetransistor aus
irq_p1:	add r3, r2, #40		@ Zeiger auf Vergleichswert pwm2
	ldm r3, {r0,r1}
	cmp r5, r1
	cmpeq r4, r0		@ Vergleichswert > Timerwert ?
	bcc irq_p2		@ ja--> noch nicht erreicht
	mov r1, #(1<<GPIO_LADEN_R)
	str r1, [r7,#40]	@ Ladetransistor aus
irq_p2:	add r3, r2, #48		@ Zeiger auf Vergleichswert pwm3
	ldm r3, {r0,r1}
	cmp r5, r1
	cmpeq r4, r0		@ Vergleichswert > Timerwert ?
	bcc irq_p3		@ ja--> noch nicht erreicht
	mov r1, #(1<<GPIO_LADEN_H)
	str r1, [r7,#40]	@ Ladetransistor aus
irq_p3:
	bl naechster_vergleichswert_setzen
	bcs irq_timer		@ wenn naechster Vergleichswert bereits erreicht-->
irq_ret:pop {r0-r5,r7-r8,lr}
	subs pc, lr, #4		@ Ruecksprung vom Interrupt

adr_irq_routine:
	.word irq_routine

irq_init:	@ Rueckgabe wenn erfolgreich: r0=0
	push {r1-r2,lr}
	mrs r0, cpsr            @ aktueller Modus in r0 sichern
	mov r1, #0xD2           @ in IRQ-Modus schalten
        msr cpsr_ctl, r1
        mov sp, #0x6000         @ Stack Pointer fuer IRQ-Modus setzen
        msr cpsr_ctl, r0        @ in vorherigen Modus zurueck
	mov r2, #0x18		@ Adresse des irq-Interrupt-Vectors
	ldr r1, adr_irq_routine	@ Adresse der irq_routine
	sub r1, r2
	sub r1, #8		@ Berechung der Sprungdistanz
	lsr r1, #2		@ Dividieren durch 4 fuer Distanz in 4-Byte-Worten
	add r1, #0xEA000000	@ Code des Sprungbefehls addieren
	str r1, [r2]		@ irq-Interrupt-Vector setzen
	@ Flags zum IRQ erlauben setzen, im CPSR und im Interrupt-Controller:
	mrs r0, cpsr
	bic r0, #0x80		@ IRQ-Disable auf 0 setzen
	msr cpsr_ctl, r0
	mov r0, #(1<<1)	@ IRQ 1 erlauben fuer Systemtimer Compare1
	str r0, [r9,#0x210]	@ in "Enable IRQs 1" entsprechendes Bit setzen
	@mov r0, #(1<<1)|(1<<3)	@ IRQ 1 und IRQ 3 erlauben fuer Systemtimer Compare1 und Compare3
	@str r0, [r9,#0x210]	@ in "Enable IRQs 1" entsprechende Bits setzen
	ldr r0, [r2]		@ irq-Vector nochmals lesen
	sub r0, r1		@ vergleichen mit was es sein sollte
	pop {r1-r2,pc}

@ ---------------------------------------------------------------------
@ AD-Wandler mit MCP3208
@
@ Um den AD-Wandler anzusprechen muss CS auf Low gesetzt werden.
@ Auf CLK werden dann ... positive Pulse gesendet mit jeweils
@ mindestens 250ns High und 250ns Low.
@ Dabei wird gleichzeitig etwas ueber DIN geschickt, und ueber DOUT
@ das Resultat eingelesen.

.equ AD_CS, 8
.equ CLK, 11
.equ DIN, 10
.equ DOUT, 9

	.data
referenzspannung:
	.word 2457	@ Uref in mV (ausgemessen)
	.text

clkpause:	@ mindestens 250ns warten, besser etwas mehr (maximal 50us)
	push {r0,lr}
	mov r0, #1
	bl microwait
	pop {r0,pc}

bit_ausgeben:	@ Eingabe: r4 untere 5 Bits
		@ Rueckgabe: r4 = (r4<<1)
	push {r0-r1,lr}
	mov r1, r4,lsr#4
	mov r0, #DIN
	bl gpio_ein_aus
	lsl r4, #1
	pop {r0-r1,pc}

bit_einlesen:	@ Eingabe: r3=bisheriges Resultat, r6=Startflag, r7=GPIO-Adresse
		@ Rueckgabe: r3, r6 = aktualisierte Werte
	push {r0,lr}
	ldr r0, [R7,#0x34]	@ GPIO-Inputs
	lsr r0, #DOUT
	and r0, #1
@ Test auf Startbit nicht noetig wenn wir am Ende nur unterste 12 Bits behalten
@	tst r6, #1	@ Startflag schon gesetzt?
@	bne be1		@ ja-->
@	tst r0, #1	@ nein: wurde Nullbit als Start empfangen?
@	moveq r6, #1	@ ja: Startflag setzen
@	b be2
be1:	lsl r3, #1
	add r3, r0	@ Bit im Resultat anfuegen
be2:	pop {r0,pc}

adwandlung: @ Eingabe: r0=Kanal (0...7), r1=Anzahl Aufsummierungen (nur 2^n erlaubt)
	    @ Rueckgabe: r3=Resultat (bereits durch Aufsummierung dividiert)
	push {r0-r2,r4-r7,r9-r10,lr}
        ldr r7, =gpio_adresse
	ldr r7, [r7]
	orr r4, r0, #0x18  @ zu sendendes Kommando: Startbit+SGL+Kanal
	mov r2, r1
	mov r9, #0	@ r9 fuer Aufsummierungen
	mov r10, r2	@ r10 = Anzahl Aufsummierungen
ad_sum:	push {r4}
	mov r0, #AD_CS	@ CS fuer AD-Wandler (MCP3208)
	mov r1, #0
	bl gpio_ein_aus	@ CS auf Low
	mov r3, #0	@ Ergebnis vorbereiten
	mov r6, #0	@ Startflag fuer Empfang von Ergebnis
	mov r5, #19	@ 19 Bits senden/empfangen
	bl clkpause	@ Synchronisation von clkpause, eventuell nicht noetig
ad_1:	bl bit_ausgeben
	bl clkpause
	mov r0, #CLK
	mov r1, #1
	bl gpio_ein_aus	@ CLK auf High
	bl bit_einlesen
	bl clkpause
	mov r1, #0
	bl gpio_ein_aus	@ CLK auf Low
	subs r5, #1
	bne ad_1
	mov r0, #AD_CS
	mov r1, #1
	bl gpio_ein_aus	@ CS auf High
	bl clkpause	@ CS mindestens so lange auf High
	mov r0, #0xFF
	add r0, #0xF00	@ r0=0xFFF = unterste 12 Bits
	and r3, r0	@ r3=Resultat, nur unterste 12 Bits behalten
	pop {r4}
	add r9, r3	@ r9=Ausummiertes Resultat
	subs r2, #1
	blne warten_zwischen_wandlungen
	tst r2,r2
	bne ad_sum
ad_3:	lsrs r10, #1
	beq ad_4
	lsr r9, #1	@ Aufsummiertes dividieren
	b ad_3
ad_4:	mov r3, r9
	pop {r0-r2,r4-r7,r9-r10,pc}
warten_zwischen_wandlungen:
	push {r0,lr}
	mov r0,#50	@ ergibt eine Totalzeit pro Wandlung von etwa 135 us
	bl microwait
	pop {r0,lr}

messwert_in_spannung_umrechnen:	@ Eingabe: r3=Messwert (12 Bit)
				@ Rueckgabe: r3=Spannung in MilliVolt
	push {r2,lr}
	ldr r2, =referenzspannung
	ldr r2, [r2]
	mul r3, r2	@ U = Uref/4096*Messwert = Uref*Messwert/4096
	add r3, #2048	@ fuer korrekte Rundung
	lsr r3, #12	@ Division durch 4096
	pop {r2,pc}

strom_ausrechnen:
	@ Eingabe: r0=Widerstand in MilliOhm, r1=Spannung1, r2=Spannung2 in mV
	@ Rueckgabe: r3=Strom in MilliAmpere
	push {r2,r4,lr}		@ U=R*I, I=U/R
	subs r3, r1, r2		@ r3=r1-r2
	subcc r3, r2, r1	@ Absolutwert
	mov r2, #1000		@ Faktor 1000 damit wir MilliAmpere erhalten
	mul r2, r3
	mov r3, r0		@ 1000*mV dividieren durch mOhm ergibt mA
	add r2, r3,lsr#1	@ Halber Teiler addieren fuer korrekte Rundung
	bl divmod		@ Positive Zahlen dividieren: r2 /= r3, r4=Rest
	mov r3, r2
	pop {r2,r4,pc}

@ ---------------------------------------------------------------------
@ Divisionen

divu:	@ Positive Zahlen dividieren: r0 /= r2
	push {r1,r3,lr}
	mov r1, #0	@ Rest=0
	mov r3, #32	@ 32 Bits behandeln
divu1:	lsl r1, #1
	lsls r0, #1
	addcs r1, #1	@ Bits von r0 nach links ins r1 schieben
	cmp r1, r2	@ r1>=r2, Rest>=Teiler
	addcs r0, #1	@ ja: Resultat-Bit setzen
	subcs r1, r2	@ ja: und r2 von r1 Subtrahieren
	subs r3, #1	@ naechstes Bit
	bne divu1	@ Resultat ist jetzt in r0
	pop {r1,r3,pc}

divs:	@ Vorzeichenbehaftete Zahlen dividieren: r0 /= r2
	push {r1-r2,lr}
	mov r1, #0	@ Vorzeichenflag: 0=positiv, 1=negativ
	tst r0,r0	@ r0<0 ?
	eormi r1, #1	@ ja: Vorzeichenflag umkehren
	rsbmi r0,r0,#0	@     r0 = -r0
	tst r2,r2	@ r2<0 ?
	eormi r1, #1	@ ja: Vorzeichenflag umkehren
	rsbmi r2,r2,#0	@     r2 = -r2
	bl divu
	tst r1, #1	@ Vorzeichen negativ?
	rsbne r0,r0,#0	@ ja: Ergebnis negativ machen
	pop {r1-r2,pc}

divumod: @ Positive Zahlen dividieren: r0 /= r2, r1 = Rest
	push {r3,lr}
	mov r1, #0	@ Rest=0
	mov r3, #32	@ 32 Bits behandeln
divum1:	lsl r1, #1
	lsls r0, #1
	addcs r1, #1	@ Bits von r0 nach links ins r1 schieben
	cmp r1, r2	@ r1>=r2, Rest>=Teiler
	addcs r0, #1	@ ja: Resultat-Bit setzen
	subcs r1, r2	@ ja: und r2 von r1 Subtrahieren
	subs r3, #1	@ naechstes Bit
	bne divum1	@ Resultat ist jetzt in r0
	pop {r3,pc}	@ und Rest in r1

divu_r1_10:	@ r1 durch 10 dividieren
	push {r0,r2,lr}
	mov r2, #10
	mov r0, r1
	bl divu		@ r0=r0/r2  provi. das waehre noch optimierbar
	mov r1, r0
	pop {r0,r2,pc}

@ ---------------------------------------------------------------------
@ Grafik in einem definierten Bereich (Fenster)
@
	.data
FensterDaten:
	.word 0		@  #0 x0 Pixelposition unten links
	.word 1079	@  #4 y0 Pixelposition unten links
	.word 0		@  #8 x1 Userkoordinaten unten links
	.word 0		@ #12 y1 Userkoordinaten unten links
	.word 1919	@ #16 x2 Userkoordinaten oben rechts
	.word 1079	@ #20 y2 Userkoordinaten oben rechts
	.word 1920	@ #24 Breite in Pixel
	.word 1080	@ #28 Hoehe in Pixel
	.word 0		@ #32 xscale = 2^16*Breite/(x2-x1)
	.word 0		@ #36 yscale = 2^16*Hoehe/(y2-y1)
	.text
adrFensterDaten:	.word FensterDaten

grafik_setposition:	@ r0,r1 = x0,y0 Pixelwerte, r2=Breite, r3=Hoehe, r4=Zeiger auf FensterDaten
			@ muss als erstes aufgerufen werden um FensterDaten auszufuellen
	push {lr}
	str r0, [r4,#0]		@ x0 speichern
	str r1, [r4,#4]		@ y0
	str r2, [r4,#24]	@ Breite
	str r3, [r4,#28]	@ Hoehe
	pop {pc}

grafik_init:	@ r0,r1 = x1,y1 Userkoordinaten, r2,r3 = x2,y2 Userkoordinaten, r4=Zeiger auf FensterDaten
		@ zuvor grafik_setposition aufrufen um in FensterDaten Pixelwerte zu setzen
	push {r0-r2,lr}
	str r0, [r4,#8]		@ x1 speichern
	str r1, [r4,#12]	@ y1
	str r2, [r4,#16]	@ x2
	str r3, [r4,#20]	@ y2
	sub r2, r0		@ r2=x2-x1
	ldr r0, [r4,#24]
	lsl r0, #16		@ r0=Breite*2^16
	bl divu			@ Division: r0=r0/r2
	str r0, [r4,#32]	@ xscale = Breite*2^16/(x2-x1)
	sub r2, r3, r1		@ r2=y2-y1
	ldr r0, [r4,#28]
	lsl r0, #16		@ r0=Hoehe*2^16
	bl divu
	str r0, [r4,#36]	@ yscale = Hoehe*2^16/(y2-y1)
	pop {r0-r2,pc}

grafik_punkt:	@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
		@ es wird der entsprechende Punkt gesetzt (im Normal-Modus, andere Moden noch nicht programmiert)
	push {r0-r1,r5,lr}
	ldr r5, [r4,#8]		@ x1
	subs r0, r5		@ x-x1
	bcc pu_ret		@ wenn x<x1 --> Fehler, kein Punkt setzen
	ldr r5, [r4,#32]
	mul r0, r5		@ xscal*(x-x1)
	add r0, #(1<<15)	@ zur korrekten Rundung
	lsr r0, #16		@ Division durch 2^16
	ldr r5, [r4,#24]	@ Breite
	cmp r0, r5		@ Groesser gleich Breite?
	bcs pu_ret		@ ja --> Fehler, kein Punkt setzen
	ldr r5, [r4,#0]
	add r0, r5		@ x0+xscal*(x-x1)/2^16
	ldr r5, [r4,#12]	@ y1
	subs r1, r5		@ y-y1
	bcc pu_ret		@ wenn y<y1 --> Fehler, kein Punkt setzen
	ldr r5, [r4,#36]
	mul r5, r1		@ yscal*(y-y1)
	add r5, #(1<<15)	@ zur korrekten Rundung
	lsr r5, #16		@ Division durch 2^16
	ldr r1, [r4,#28]	@ Hoehe
	cmp r5, r1		@ Groesser gleich Hoehe?
	bcs pu_ret		@ ja --> Fehler, kein Punkt setzen
	ldr r1, [r4,#4]
	sub r1, r5		@ y0-yscal*(y-y1)/2^16
	bl punkt_setzen
pu_ret:	pop {r0-r1,r5,pc}

grafik_clear:	@ r4=Zeiger auf FensterDaten, r2=Farbe
	push {r0,r1,r3,r5,lr}
	ldr r5, [r4,#4]		@ y0
	add r5, #1		@ r5=yGrenze = y0+1
	ldr r0, [r4,#28]	@ Hoehe
	sub r1, r5, r0		@ r1=y0+1-Hoehe
	ldr r0, [r4]		@ x0
	ldr r3, [r4,#24]	@ Breite
	add r3, r0		@ r3=xGrenze = x0+Breite
grcl_1:	ldr r0, [r4]		@ x0
grcl_2:	bl punkt_setzen		@ r0=x, r1=y, r2=Farbe
	add r0, #1
	cmp r0, r3
	bne grcl_2
	add r1, #1
	cmp r1, r5
	bne grcl_1
	pop {r0,r1,r3,r5,pc}
	
grafische_darstellung_init:  @ Darstellung fuer Entlade- und Lade-Kurven
			     @ Eingabe: r2=Farbe zum Loeschen oder -1 fuer ohne Loeschen
			     @          r3=Zeit in Stunden oder Minuten wenn negativ
	push {r0-r6,lr}
	mov r5, r2		@ r5=Loeschfarbe oder -1
	mov r6, #3600		@ Faktor zum von Stunden in Sekunden umrechnen
	tst r3,r3		@ r3 negativ?
	rsbmi r3, r3, #0	@ ja: Zeit in Minuten, r3 positiv machen
	movmi r6, #60		@     und Faktor auf 60 setzen
	mul r6, r3		@ r6=Zeit in Sekunden
	ldr r4, adrFensterDaten
	mov r0, #0		@ x0=0
	mov r1, #1000
	add r1, #79		@ y0=1079
	mov r2, #1920		@ Breite = Gesamte Bildschirmbreite
	mov r3, #540		@ Hoehe = ca. halbe Bildschirmhoehe
	bl grafik_setposition	@ r0,r1 = x0,y0 Pixelwerte, r2=Breite, r3=Hoehe, r4=Zeiger auf FensterDaten
	mov r0, #0
	mov r1, #0
	mov r2, r6		@ x2 = Zeit in Sekunden
	mov r3, #2000		@ y2 = 2000 mV
	bl grafik_init	@ r0,r1 = x1,y1 Userkoord., r2,r3 = x2,y2 Userkoord., r4=Zeiger auf FensterDaten
	mov r2, r5
	cmn r2, #1		@ Loeschfarbe == -1 ?
	blne grafik_clear	@ nein: Grafikbereich loschen
	pop {r0-r6,pc}

grafische_darstellung:	@ Eingabe: r4=Zeiger auf uhrdaten, r6=Zeiger auf Messwerte
	push {r0-r4,lr}
g1:	ldrb r3, [r4,#4]	@ Sekunden, aktuelle Zeit einlesen
	ldrb r1, [r4,#5]	@ Minuten
	ldrb r0, [r4,#6]	@ Stunden
	ldrb r2, [r4,#4]	@ Sekunden
	cmp r2, r3
	bne g1			@ nochmals falls Sekunden gerade geaendert haben
	mov r3, #60
	mul r0, r3		@ Stunden*60
	add r0, r1
	mul r0, r3		@ (Stunden*60+Minuten)*60
	add r0, r2		@ x = Zeit in Sekunden
	ldr r4, adrFensterDaten
	ldr r2, [r4,#16]	@ x2
	cmp r2, r0		@ x>x2 ?
	blcc grafische_darstellung_xzoomout	@ ja: Bereich erhoehen und bisheriges neue zeichnen
	ldr r1, [r6,#4]		@ Spannung links
	mov r2, #0
	bl daten_speichern
	mov r2, #0xFF00		@ Gruen
	mov r3, #0		@ Modus=Normal
	bl grafik_punkt		@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
	ldr r1, [r6,#12]	@ Spannung rechts
	mov r2, #1
	bl daten_speichern
	mov r2, #0xFF		@ Rot
	bl grafik_punkt		@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
	ldr r1, [r6,#44]	@ Spannung Hochvolt
	bl divu_r1_10		@ provi. Division durch 10 damits in Grafik passt
	mov r2, #2
	bl daten_speichern
	mov r2, #0xFF		@ Rot
	add r2, #0xFF00		@ +Gruen=Gelb
	bl grafik_punkt		@ r0,r1 = x,y Userkoordinaten, r2=Farbe, r3=Modus, r4=Zeiger auf FensterDaten
	pop {r0-r4,pc}

grafische_darstellung_xzoomout:	@ Eingabe: r0=Anzahl bisherige Messwerte+1, r4=Zeiger auf FensterDaten
	push {r0-r3,r5,lr}
	sub r5, r0, #1		@ Anzahl bisherige Messwerte
	ldr r0, [r4,#16]	@ x2
	lsl r0, #1		@ xBereich verdoppeln
	cmp r0, #3600		@ kleiner als 3600?
	mvncc r2, #60-1		@ ja: Zeit in Minuten angeben (Division durch -60 ergibt Negatives Resultat)
	movcs r2, #3600		@ sonst Zeit in Stunden
	bl divs			@ Division mit Vorzeichen: r0=r0/r2
	mov r3, r0
	mov r2, #0		@ Farbe=schwarz
	bl grafische_darstellung_init	@ r2=Farbe zum loeschen oder -1, r3=xmax in Std oder in Min wenn negativ
	bl grafische_darstellung_neuzeichnen
	pop {r0-r3,r5,pc}

grafische_darstellung_neuzeichnen:	@ r5=Anzahl bisherige Messwerte
	push {r0-r4,r6-r7,lr}
	mov r6, r5		@ Anzahl bisherige Messwerte
	mov r7, #0xFF00		@ Gruen fuer ersten Durchlauf
	mov r3, #0		@ Modus=Normal
	mov r2, #0		@ Links
gnz1:	mov r4, #0		@ 0 fuer ersten Datenpunkt
	mov r0, #0		@ x=0
gnz2:	bl daten_auslesen	@ Rueckgabe: r1=y, r4=aktualisiert
	push {r2,r4}
	ldr r4, adrFensterDaten
	mov r2, r7		@ Farbe
	bl grafik_punkt
	pop {r2,r4}
	add r0, #1		@ x=x+1
	subs r6, #1
	bne gnz2
	mov r6, r5		@ Anzahl bisherige Messwerte
	mov r7, #0xFF		@ Rot fuer 2. Durchlauf
	add r2, #1		@ Rechts beim 2. Durchlauf, Hochvolt beim 3.Durchlauf
	cmp r2, #2
	addeq r7, #0xFF00	@ Gelb fuer 3. Durchlauf
	cmp r2, #3
	bne gnz1
	pop {r0-r4,r6-r7,pc}

@ ---------------------------------------------------------------------
@ Daten speichern
@
.equ SPSIZE, 40000  @ Speichergroesse in 4-Byte-Worten

daten_speichern:  @ Eingabe: r1=zu speichernder Wert, r2=Akku (0=Linker, 1=Rechter Akku, 2=Hochvolt-Akku)
	push {r2,r4-r5,lr}
	ldr r5, adrDatengrab
	and r2, #3
	add r5, r2,lsl#2	@ r5 = Zeiger auf Zeiger auf Links- oder Rechts- oder Hochvolt-Werte
	ldr r4, [r5]		@ r4 = Zeiger auf entsprechenden Datenbereich
	ldr r2, [r5,#16]	@ r2 = Zeiger auf Speicherende des Bereichs
	cmp r4, r2		@ Speicherende erreicht?
	strne r1, [r4],#4	@ Daten speichern mit postincrement
	strne r4, [r5]		@ Zeiger speichern
	pop {r2,r4-r5,pc}

daten_auslesen:	 @ Eingabe: r2=Links/Rechts/Hochvolt (0=Links, 1=Rechts, 2=Hochvolt-Akku), r4=Zeiger oder 0 fuer ersten Wert
		 @ Rueckgabe: r1=Wert, r4=aktualisierter Zeiger
	push {lr}
	teq r4,#0
	bne da1
	cmp r2, #1
	ldrcc r4, adrDatenL
	ldreq r4, adrDatenR
	cmp r2, #2
	ldreq r4, adrDatenH	@ r4 = Zeiger auf Zeiger auf Anfang Links-, Rechts- oder Hochvolt-Werte
da1:	ldr r1, [r4],#4		@ Daten mit Postincrement lesen
	pop {pc}

get_datengrab_groesse:	@ Rueckgabe: r0=Groesse in Bytes
	push {r1,lr}
	ldr r1, adrDatengrab
	ldr r0, adrDaten_end
	sub r0, r1
	pop {r1,pc}

	.data
Datengrab:	@ dies sollte ganz am Schluss des Programms stehen
	.word DatenL	@  0  Zeiger auf Links-Werte
	.word DatenR	@  4  Zeiger auf Rechts-Werte
	.word DatenH	@  8  Zeiger auf Hochvolt-Werte
	.word DatenV	@ 12  Zeiger auf Reserve
	.word DatenR	@ 16  Zeiger auf Speicherende Links
	.word DatenH	@ 20  Zeiger auf Speicherende Rechts
	.word DatenV	@ 20  Zeiger auf Speicherende Hochvolt
	.word Daten_end @ 20  Zeiger auf Speicherende Reserve
DatenL:	.skip 4*SPSIZE	@ Platz fuer 40000 4-Byte-Worte, zum 10 Std jede Sek speichern
DatenR:	.skip 4*SPSIZE	@ Platz fuer 40000 4-Byte-Worte, zum 10 Std jede Sek speichern
DatenH:	.skip 4*SPSIZE	@ Platz fuer 40000 4-Byte-Worte, zum 10 Std jede Sek speichern
DatenV:	.skip 4         @ Reserve
Daten_end: .word 0
	.text
adrDatengrab:	.word Datengrab
adrDatenL:	.word DatenL	@ Startadresse von Werten fuer Linken Akku
adrDatenR:	.word DatenR	@ Startadresse von Werten fuer Rechten Akku
adrDatenH:	.word DatenH	@ Startadresse von Werten fuer Hochvolt-Akku
adrDaten_end:	.word Daten_end

@ Ende des Programms
@ ---------------------------------------------------------------------
