@ debugtest.s  zum Einfuegen in akkulader.s
@ muesste fuer aktuelle Version noch angepasst werden

.ifdef TRANSTEST
@ Test der Transistoren ohne eingesetzte Akkus:
testloop:
	mov r1, #0	@ alle Transistoren ausschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #1	@ Transistoren einschalten
	mov r0, #GPIO_LADEN_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_LADEN_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_L
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	mov r1, #1
	mov r0, #GPIO_ENTLAD_R
	bl gpio_ein_aus
	bl pause
	mov r1, #0
	bl gpio_ein_aus	@ und wieder aus
	b testloop
pause:	push {r0,lr}
	mov r0, #4000
	add r0, #1000
	bl milliwait	@ 5 Sekunden warten
	pop {r0,pc}
.endif @ TRANSTEST

.ifdef UHRTEST
@ Test der Interrupt-Uhr:
	.data
uhrtest:.string "Uhr testen:"
	.align
	.text
	ldr r3, =uhrtest
	bl printstring
	bl print_newline
	mov r5, #60
	ldr r4, adrUhrdaten
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5
	beq L1
	tst r3, #1	@ Test alle 2 Sekunden: PWM1 erniedrigen
	bleq pwm1_aendern
	tst r3, #0	@ Test alle 1 Sekunden: PWM2 erhoehen
	bleq pwm2_aendern
	mov r5, r3		@ r5=Sekunden
	ldrb r6, [r4,#5]	@ Minuten lesen
	ldrb r3, [r4,#6]	@ Stunden lesen
	mov r2, #2		@ Format: 2 Stellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r6
	add r2, #'0'<<24	@ Format: mit 0 auffuellen
	bl printzahl
	mov r3, #':'
	bl printchar
	mov r3, r5
	bl printzahl
	mov r2, #4		@ noch PWM1 und PWM2 drucken
	ldrb r3, [r4,#16]	@ pwm1
	bl printzahl
	ldrb r3, [r4,#17]	@ pwm2
	bl printzahl
	bl pwm_check	@ zum Debuggen
	beq L2		@ ok -->
	bl pwm_restart
	mov r2, #12
	bl printzahl	@ Zaehler Timer
	mov r3, r6
	bl printzahl	@ Zaehler PWM
	bl print_newline
L2:	mov r0, #0		@ wieder auf Zeilenanfang
	b L1

pwm2_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm2
	ldrb r0,[r2]
	add r0,#1
	b pwm1_1
pwm1_aendern:
	push {r0,r2,lr}
	ldr r2, =pwm1
	ldrb r0,[r2]
	sub r0,#1
pwm1_1:	tst r0,r0		@ r0<0 ?
	addmi r0,#100		@ ja: 100 addieren
	cmp r0,#100		@ r0>=100 ?
	subcs r0,#100		@ ja: 100 subtrahieren
	strb r0,[r2]
	pop {r0,r2,pc}
.endif @ UHRTEST

.ifdef ADTEST
	.data
adtest:.string "AD-Wandler testen:"
	.align
	.text
	ldr r3, =adtest
	bl printstring
	bl print_newline
	ldr r4, adrUhrdaten
	ldr r6, adrMesswerte
	mov r5, #0	@ r5=Sekunden
L1:	ldrb r3, [r4,#4]	@ Sekunden lesen
	cmp r3, r5		@ Sekunden geaendert?
	beq L1			@ nein--> warten
	mov r5, r3
	push {r0,r1}	@ x,y retten
	push {r0-r1}	@ x retten
	mov r0, #0	@ Kanal 0, Ladestrom links
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#0]
	mov r2, #6	@ Format "%6d"
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #1	@ Kanal 1, Akku-Spannung links
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#4]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #2	@ Kanal 2, Ladestrom rechts
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#8]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	push {r0-r1}	@ x retten
	mov r0, #3	@ Kanal 3, Akku-Spannung rechts
	mov r1, #256	@ Anzahl Aufsummierungen
	bl adwandlung	@ r3=Resultat
	str r3, [r6,#12]
	pop {r0-r1}	@ x zurueck
	bl printzahl
	ldrb r3, [r4,#4]	@ Sekunden lesen
	bl printzahl
	bl print_newline	@ auf naechster Zeile in mV umgerechnete Werte
	ldr r3, [r6,#0]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#4]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#8]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	ldr r3, [r6,#12]
	bl messwert_in_spannung_umrechnen
	bl printzahl
	bl printblank
	bl printblank
	bl print_mV
	bl print_newline	@ auf naechster Zeile Lade-Stroeme anzeigen
	push {r0-r2}
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	ldr r1, [r6,#0]
	ldr r2, [r6,#4]
	bl strom_ausrechnen
	pop {r0-r2}
	bl printzahl		@ Strom links
	bl printblank
	bl print_mA
	bl printblank
	bl printblank
	push {r0-r2}
	mov r0, #2000
	add r0, #500		@ 2.5 Ohm = 2500 mOhm
	ldr r1, [r6,#8]
	ldr r2, [r6,#12]
	bl strom_ausrechnen
	pop {r0-r2}
	bl printzahl		@ Strom rechts
	bl printblank
	bl print_mA
	cmp r3, #18+10	@ Regelungsversuch auf 18 mA
	blcs zu_hoch
	cmp r3, #18-10	@ Regelungsversuch
	blcc zu_niedrig
	pop {r0,r1}	@ x,y zurueck
	b L1
zu_hoch:
	push {r0,lr}
	ldrb r0, [r4,#17]	@ pwm2
	subs r0, #1
	strcsb r0, [r4,#17]
	pop {r0,pc}
zu_niedrig:
	push {r0,lr}
	ldrb r0, [r4,#17]	@ pwm2
	add r0, #1
	cmp r0, #99
	strccb r0, [r4,#17]
	pop {r0,pc}

.endif @ ADTEST
