//  hauptprog.c  Hauptprogramm zum ein Assembler-Unterprogramm aufrufen

#define BCM2708_PERI_BASE        0x20000000
#define GPIO_BASE  (BCM2708_PERI_BASE + 0x200000) /* GPIO controller */
#define TIMER_BASE (BCM2708_PERI_BASE + 0x3000) /* System-Timer */
#define INTERRUPT_BASE (BCM2708_PERI_BASE + 0xB000) /* Interrupt-Controller */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

#define BLOCK_SIZE (4*1024)

// Set up a memory regions to access GPIO
unsigned int *setup_io(int base,int block_size)
{
 void *gpio_map;
 int  fd;
 if((fd=open("/dev/mem", O_RDWR|O_SYNC)) < 0)
  {
   fprintf(stderr,"Fehler bei open(\"/dev/mem\") fd=%d\n",fd);
   return NULL;
  }
 gpio_map = mmap(
      NULL,             //Any adddress in our space will do
      block_size,       //Map length
      PROT_READ|PROT_WRITE,// Enable reading & writting to mapped memory
      MAP_SHARED,       //Shared with other processes
      fd,               //File to map
      base         //Offset to GPIO peripheral
   );
 close(fd); //No need to keep fd open after mmap
 if(gpio_map==MAP_FAILED)
  {
   fprintf(stderr,"Fehler bei mmap(NULL, blocksize=%d, ... base=0x%X)\n",
	   block_size, base);
   return NULL;
  }
 return (unsigned int*)gpio_map;
}

int main()
{
  int n;
  unsigned int *gpio_map,*timer_map,*interrupt_map;
  gpio_map=setup_io(GPIO_BASE,BLOCK_SIZE);
  timer_map=setup_io(TIMER_BASE,0x20);
  interrupt_map=setup_io(INTERRUPT_BASE,BLOCK_SIZE);
  n=meinunterprogramm(gpio_map,timer_map,interrupt_map);
  fprintf(stderr,"Rueckgabewert = %d = 0x%X\n",n,n);//test
  munmap(gpio_map,BLOCK_SIZE);
  munmap(timer_map,0x20);
  munmap(interrupt_map,BLOCK_SIZE);
  return n;
}
